package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.lang.*;
import java.util.*;
import java.awt.*;  
import javax.swing.*;

class BestSegJFrame extends JFrame implements javax.swing.event.ChangeListener, java.awt.event.WindowListener{
	BestSegCanvas canvas=null;
	Segmenter parent;
	int	mouseStartX, mouseStartY; 	// Used when dragging center of postage stamp region around
	int sectionNumber;
	JTextField Xtext,Ytext,Ztext,BrightText,AvgGlowText;
	int myWidth=10;
	int myHeight=10;
	
// catch WindowListener events  
	public void windowActivated(java.awt.event.WindowEvent event) {}
	public void windowDeactivated(java.awt.event.WindowEvent event) {}
	public void windowOpened(java.awt.event.WindowEvent event) {}
	public void windowIconified(java.awt.event.WindowEvent event) {}
	public void windowDeiconified(java.awt.event.WindowEvent event) {}
	public void windowClosing(java.awt.event.WindowEvent event) {
        talk("Exit via 'Quit' option in 'file' menu");
        setVisible(true);
		}
		
	public void stateChanged(javax.swing.event.ChangeEvent e) {
		talk("window state changed: "+e);			
		} 
		
	public void windowClosed(java.awt.event.WindowEvent event) {
        talk("Exit via 'Quit' option in 'file' menu");
        setVisible(true);
		}
	
public void sepuku() {
	if(canvas != null)
		canvas.sepuku();
	canvas=null;
	parent=null;
	setVisible(false);
	//  talk("++++++++++BestSegJFrame.sepuku()");
	dispose();
	}	
	
public void pixelReport(int x, int y, int bri,int avg) {
	Xtext.setText(" X = "+x);
	Ytext.setText(" Y = "+y);
	Ztext.setText("section "+sectionNumber);
	BrightText.setText("pointGlow="+bri);
	AvgGlowText.setText("averageGlow="+avg);
	}

	public boolean confirmSize(int theWidth, int theHeight) {
		if(myWidth != theWidth || myHeight != theHeight)
			return false;
		else 
			return true;
		}
	
	public BestSegJFrame(int stampWidth,int stampHeight, int stampXorig, int stampYorig, 
				SegPic bestPic, Segmenter parent) {	
		super("bestYet segmentation ("+bestPic.wholeCols+"x"+bestPic.wholeRows+
				"). Mouse click relocates stamp window.");				
		this.parent=parent;
		setBackground(Color.white);
		getContentPane().setLayout(new BorderLayout());
		canvas = new BestSegCanvas(stampWidth,stampHeight,stampXorig,stampYorig, 
				bestPic, this);
		setSize(bestPic.wholeCols,bestPic.wholeRows+20);
		myWidth = bestPic.wholeCols;
		myHeight = bestPic.wholeRows;
		this.sectionNumber = bestPic.sectionNumber;
		WidgetMaker wmk = new WidgetMaker(this);
		Xtext = wmk.makeAJTextField((""+0),12,Color.yellow);
		Ytext = wmk.makeAJTextField((""+0),12,Color.yellow);
		Ztext = wmk.makeAJTextField((""+0),12,Color.yellow);
		AvgGlowText = wmk.makeAJTextField((""+0),12,Color.yellow);
		BrightText = wmk.makeAJTextField((""+0),12,Color.yellow);
		Ztext.setText("section "+sectionNumber);
		JPanel pixReport = new JPanel();
		pixReport.setLayout(new GridLayout(1,0));
		pixReport.add(Ztext);
		pixReport.add(Xtext);
		pixReport.add(Ytext);
		pixReport.add(BrightText);
		pixReport.add(AvgGlowText);		
		getContentPane().add("Center",canvas);
		getContentPane().add("North",pixReport);
		setVisible(true);
		addWindowListener(this);
		// addChangeListener(this);
		repaint();
		}
	
	public void changeStampSizes(int newStampWidth, int newStampHeight) {
		if(canvas != null)
			canvas.changeStampSizes( newStampWidth,  newStampHeight);
		}
			
	static void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}

	public void newBestPic(SegPic theBestPic) {
		setVisible(true);
		this.sectionNumber = theBestPic.sectionNumber;
		Ztext.setText("section "+sectionNumber);
		canvas.newBestPic(theBestPic);
		}
	
	public void paint(Graphics g) {
		//talk("This should never happen. BestSegFrame.paint() called");
		paint2D((Graphics2D)g);
		}
		
	public void update(Graphics g) {
		// talk("BestSegFrame.update() called. Should never happen");
		paint2D((Graphics2D)g);
		}

	public void update2D(Graphics2D g) {
		paint2D(g);
		}

	public void paint2D(Graphics2D g) {
		canvas.paint2D(g);
		}
		
		
}
