package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.lang.*;
import java.util.*;
import java.awt.*;  
import javax.swing.*;

class BlackWhiteFltr {
	SegmenterNode nd=null;

	public BlackWhiteFltr(SegmenterNode nd) {
		this.nd=nd;
		}

	public void tellWhatYouDo() {
		nd.talk("");
		nd.talk("The BlkWht filter has a single input raster.");
		nd.talk("It has one parameter, 'thresh'. At each pixel, its output is zero");
		nd.talk("if the input pixel value is less than thresh and its output is 255");
		nd.talk("if the input pixel value is >= thresh");
		}
		
	public boolean doit(short [] inras, int incols, int inrows, int thr, short [] outras) {
		if(incols != nd.rasCols || inrows != nd.rasRows) return false;
		int i, npix = nd.rasRows*nd.rasCols;
		short on=(short)255, offpix = (short)0, thresh;
		thresh = (short)(thr);
		if(nd.diags) nd.talk("BlkWhtFltr with threshold="+thresh);
		for(i=0;i<npix;i++) {
			if(inras[i]>=thresh)
				outras[i] = on;	
			else
				outras[i] = offpix;
			}	
		return true;	
		}
}