package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.io.*;
import java.lang.*;
import java.util.*;
import java.awt.*;  
import javax.swing.*;

class DeconvolutionStatusDisplay extends JFrame {
	String [] tags=null;
	String [] messages=null;
	long [] timeStamps=null;
	int ntags;
	JLabel [] labels=null;
	Point whereIWas = null;

/* when a single computer is doing all the deconvolution, this displays thee status of the
several LightSuckerClients */
	public void sepuku() {
		for(int i=0;i<ntags;i++) {
			tags[i]=null;
			messages[i]=null;
			labels[i]=null;
			}
		dispose();
		}
	
	private long timeNow() {
		return (new Date()).getTime()/1000;
		}			
	
	public long secsSinceLastReport(String uniqueTag) {
		// returns the elapsed seconds since the most recent message from the uniqueTag thing
		for(int i=0;i<ntags;i++)
			if(uniqueTag.equals(tags[i])) {
				return (timeNow() - timeStamps[i]);
				}	
		return -1;
		}
					
	public DeconvolutionStatusDisplay(String uniqueTag,String message) {
		WidgetMaker wmk = new WidgetMaker(this);
		tags = new String[1];
		messages = new String[1];
		timeStamps = new long[1];
		ntags=1;
		labels = new JLabel[1];
		tags[0] = new String(uniqueTag);
		messages[0] = new String(message);
		timeStamps[0]=timeNow();
		makeNewOne();
		}
		
		
	public DeconvolutionStatusDisplay(String uniqueTag,String message, DeconvolutionStatusDisplay oldone) {
		ntags = 1+oldone.ntags;
		tags = new String[ntags];
		messages = new String[ntags];
		labels = new JLabel[ntags];
		timeStamps = new long[ntags];
		for(int i=0;i<oldone.ntags;i++) {
			tags[i] = new String(oldone.tags[i]);
			messages[i] = new String(oldone.messages[i]);
			timeStamps[i] = oldone.timeStamps[i];
			}
		tags[ntags-1] = new String(uniqueTag);
		messages[ntags-1] = new String(message);
		timeStamps[ntags-1] = timeNow();
		whereIWas = oldone.getLocationOnScreen();
		oldone.sepuku();
		makeNewOne();
		}
		
	private void makeNewOne() {
		WidgetMaker wmk = new WidgetMaker(this);
    	getContentPane().setLayout(new BorderLayout()); 
   		setSize(500, 50+13*ntags);
   		JPanel tagpanel = new JPanel();
   		tagpanel.setLayout(new GridLayout(0,1));
   		JPanel messagepanel =  new JPanel();
   		messagepanel.setLayout(new GridLayout(0,1));
   		
   		for(int i=0;i<ntags;i++) {
   			tagpanel.add(wmk.makeAJLabel(tags[i]+"==>"));
   			labels[i] = wmk.makeAJLabel(messages[i]);
   			messagepanel.add(labels[i]);
   			}
   		getContentPane().add("Center",messagepanel);
   		getContentPane().add("West",tagpanel);
   		if(whereIWas != null)
   			setLocation(whereIWas.x,whereIWas.y);
   		setVisible(true);
   		setTitle("status report for "+ntags+" active deconvolution clients");
   		wmk=null;
		}
		

	public boolean report(String uniqueTag,String message) {
		for(int i=0;i<ntags;i++)
			if(uniqueTag.equals(tags[i])) {
				timeStamps[i] = timeNow();
				messages[i] = new String(message+"  <<"+timeStamps[i]+">>");
				labels[i].setText(messages[i]);
				return true;
				}	
		return false;
		}
		
	public void killOff(String uniqueTag) {
		for(int i=0;i<ntags;i++)
			if(uniqueTag.equals(tags[i])) {
				labels[i].setText(" is dead");
				messages[i] = new String(" is dead");
				}	
		}

}
