package staxx;

import java.io.*;
import java.lang.*;
import java.util.*;
import java.awt.*;  
import javax.swing.*;

/*  This class organizes the deconvolution process. It makes assignments to the several LightSuckerClients that volunteer
to do deconvolution tasks.
                     */
 
/*
There are N==sectsInStack sections. Call the original data d[k][i] == i-th pixel of k-th section

b[k][i] = i-th pixel of k-th section of current best approximation of deconvolved d[][]

If c[][] is any rectangular prism of data, let L(c) denote the convolution of c with the measured
point spread function (PSF). L() is thus a linear operator. Given any c, and given the measured PSF,
we can computer L(c) and this is what the LightSuckerClient() class does.

We want to find the unique b[][] such that  r L(b) == d[][] where r is a scale factor. Since the PSF 
is measured in arbitrary units, r is to be adjusted to minimize the difference || r L(b) - d[][] ||

decompose L = 1 + g S, where 1 stands for the identity operator and g is a scalar and S is the convolution
which would be zero if the confocal microscope produced zer-thickness optical sections. 

r (1 + g S)(b) = d,   which is
r b + (r*g)S(b) = d,  which is
b = (1/r) d - gS(b)   and we use this to define a fixed-point iteration that generates a sequence 
of approximations: b ,  b ,  b , ..., b
                    0    1    2        n       where
                    
b     =  (1/r) d - g S(b ),  for n=0,1,2,...
 n+1                    n


b     =  (1/r) r L(b) - g S(b ),  for n=0,1,2,...
 n+1                         n




Let Linv() denote the inverse operator to L(). Linv() is also a linear operator.  
Roughly, Linv() = I() - g S because then
L * Linv = (1 + g S)*(1 - g S) = 1 + g S - g S + g^2 S*S = 1 + g^2 S*S
and maybe g is small... 

From the defining property of the answer, b, we want:  r L(b) == d[][], we have
b = (1/r) Linv(d) which approximately equals b = (1/r) (1 - g S)(d) = (1/r) d - (g/r) S(d)


A criterion for stopping at one particular iteration....

Lets' say we generate a sequence of iterative approximations of the deconvolved image stack
got by any means:  b ,  b ,  b , ..., b
                    0    1    2        n      
Let W  = L(b ) for each j, and this W  is what LightSuckerClient() computes. Note that                   
     j      j  
                           j
each W  is an array of floats whose scaling is arbitrary. We want to use the particular
      j
b  such that, for some scale fatcor, alpha, alpha*L(b ) is the best possible approximation of the original
 m                                                   m
data, d[][]. Thus, for each j,  we want to adjust alpha to minimize
E(j,alpha) = sum_k_0_N u[k] sum_i_0_npix g[k][i] { alpha*W [k][j]  - d[k][i] }^2
                                                          j
where u[k] is a weight factor  that diminishes the importance of sections near the ends of the
stack which will not be properly deconvolved because of absence of info off-screen.

g[k][i] is a weight function that emphasizes the importance of bright voxels, g[k][i] = 0.1 + 0.9*d[k][i]/255 
or g[k][i] = 0.1 + .0035294*d[k][i]

and then find, for which j, the value of E(j,alphaOpt) is least. Just write a file telling the numerical 
values of E(1,alphaOpt), E(2,alphaOpt), E(3,alphaOpt), E(4,alphaOpt),...

Work it out that the formula for each alphaOpt is simply:

            sum_k_0_N u[k] sum_i_0_npix { W [k][i] * d[k][i] * g[k][i] }
                                           j
alphaOpt =  -------------------------------------------------
            sum_k_0_N u[k] sum_i_0_npix g[k][i]* {W [k][i]}^2
                                                   j
                                 
Then,  
E(j,alphaOpt) = sum_k_0_N u[k] sum_i_0_npix {alphaOpt^2*g[k][i]*W [k][i]}^2 - 2*alphaOpt*sum_k_0_N u[k] sum_i_0_npix  g[k][i]*W [k][i] * d[k][i]
                                                                 j                                                             j          
                         
                        + sum_k_0_N  u[k] sum_i_0_npix g[k][i]*{d[k][i] }^2
                         
 Thus, go through the leaked light data for each iteration, j, and compute
 
 A =  sum_k_0_N u[k] sum_i_0_npix { W [k][i] * d[k][i]*g[k][i] }
                                     j                            
                               
 B =  sum_k_0_N u[k] sum_i_0_npix g[k][i]*{W [k][i]}^2
                                            j
                               
 C  =  sum_k_0_N u[k] sum_i_0_npix g[k][i]*{d[k][i] }^2
 
 
 Then alphaOpt = A/B
 
 and E(j,alphaOpt) = alphaOpt^2*B - 2*alphaOpt A  + C  
 
 or, most simply,  E(j,alphaOpt) = A*A/B  -  2*A*A/B  + C = C - A*A/B
                                                     
 This calculation can be done one section at a time. Store these indices for k=0,1,...,N-1 and
 for j=1,2,3,.... as many iterations as are scheduled.
 
 Let A[j][k] =  sum_i_0_npix { W [k][i] * d[k][i] * g[k][i]}
                                j
 B[j][k] =  sum_i_0_npix g[k][i]*{W [k][i]}^2
                                   j

 C[k]  =  sum_i_0_npix g[k][i]* {d[k][i] }^2        note this does not depent on iteration number j 
 
 
 Then, for each iteration j, compute
 Aj = sum_k_0_N u[k] A[j][k]    and     Bj = sum_k_0_N u[k] B[j][k]  and  C = sum_k_0_N u[k] C[k]   
 
 and then alphaOpt = Aj/Bj and  E(j,alphaOpt) =  C - Aj*Aj/Bj    Print these and let the user decide
 from them which iteration's deconvolution to use. Presumably, use the iteration, j, having the 
 least value of Wj.                             
                                                     
                                 */

							
class Deconvolver extends JFrame implements Runnable, java.awt.event.ActionListener,java.awt.event.WindowListener {
	DeconvolverPSF DPSF; // which holds the point spread function.
	LeakedLight [] theSections;
	int [] ifDeconCalculationDone;
	long [] assignmentTimes;
	static final int maxSecs2WaitBeforeReassigning = 240; // seconds
	LightSuckerClientInterface LSCI=null;
	DeconvolutionStatusDisplay DSD=null;
	RandomAccessFile logfile=null;
	ShowDeconSectionStatus SDSS = null;
	int numSuckers=0,maxNumberOfSuckers=24;
	LightSuckerClient [] suckers = new LightSuckerClient[maxNumberOfSuckers];
	
	boolean [] isSectionCachedOnDisk;
	double [] SubfacForSubtraction;
	double lastRootMeanSquaredErrorPerpix=7777777.;
	int trend=0;
	
	
	ShowPicJPanel picJPanel=null;
	BioradFile theStack; 
	showDeconJFrame pictureDisplay = null;
	
	RandomAccessFile IterationErrorLogFIle=null;
	int rgbchan=0;
	boolean ifChanPicked=false;
	String [] sectionFIleNames;
	int sectsInStack;
	int stackWidth,stackHeight;	
	double dxy=.1,dz=.1;
	int nicesleep=10; // change this to cause deconvolving clients to sleep more
	String fileDirectory="/tmp";
	String filePrefix;
	int bytesPerLeLiSect = 8000000;
	int megabytesForSectionStack = 90;
	int maxSectionsInRam = 18;
	String rep2string = "                                                                                                 ";
	boolean ifPaused = false; // when true pause the deconvolutions

	int nomwidth=340,nomheight=360,numIterations=24,showSection=1, iterationsDone=0;
	JTextField mainParameterField,numIterationsField,startSectionField,stopSectionField,report1Field,report2Field,
			showSectionField,showSectionScaleField,lowpassWeightField,clientSectionAssignmentCountField,
			saturatedDisplayPixelsField,noGlowField,stackSizeField;
			
	JButton sepukuButton,origSectColorButton,deconSectionColorButton,lowpassButton,pauseButton,upsideDownButton,
					writeBioradStackButton,whichStackButton,chanButton;	

	boolean ifLowpassFilter=true;
	int origSectColor=0,deconSectionColor=1;
	double mainParameter=.1,showSectionScale=1.0,lowpassWeight = .002, noglow=1.0;
	int sectBeingDeconvolved=77777,startSection=0,stopSection=6,clientSectionAssignmentCount=4;
	boolean deconvolutionsInProgress=false;
	Thread deconThread = null;
	double masterRescaleFactor;
	private int MasterSwitchState = 0; /* 
		0 means nothing is happening
		1 means an iteration of deconvolutions is in progress
		2 means the current iteration of deconvolutions is complete and the sections
				are ready to have the leaked light subtracted and then be updated to disk
		3 means the subtraction of leaked light from all the deconvolved sections is in progress
		4 means the subtraction of leaked light from all the deconvolved sections is complete
		5 means writing this iterations biorad pic is in progress
		6 means writing this iterations biorad pic is in complete
		
		77 means the entire sequence of deconvolutions is complete.
		
		the only method that changes masterStateSwitch is run() and startDeconvolutionSequence().
		*/
	
		
	public Deconvolver(DeconvolverPSF DPSF,ShowPicJPanel picJPanel) {
    	super("deconvolve some channel");
		this.picJPanel=picJPanel;
		this.DPSF = DPSF;
		
		WidgetMaker wmk = new WidgetMaker(this);
		start();
		ifChanPicked=false;
    	getContentPane().setLayout(new GridLayout(0,1)); 
   		setSize(nomwidth, nomheight);
		
		chanButton = wmk.makeAJButton("red channel deconvolution");
		whichStackButton = wmk.makeAJButton("push after picking channel ->");
		JPanel chanPan = new JPanel();
		chanPan.setLayout(new GridLayout(1,2));
		chanPan.add(whichStackButton);
		chanPan.add(chanButton);
		getContentPane().add(chanPan);

		JPanel aPanel = new JPanel();
		aPanel.setLayout(new GridLayout(0,2));
		aPanel.add(wmk.makeAJLabel("per-iteration removal fraction->"));
		mainParameterField = wmk.makeAJTextField(""+trunc(mainParameter),20);
		aPanel.add(mainParameterField);
		getContentPane().add(aPanel);
		
		JPanel nPanel = new JPanel();
		nPanel.setLayout(new GridLayout(0,2));
		nPanel.add(wmk.makeAJLabel("#sects/decon client task->"));
		clientSectionAssignmentCountField = wmk.makeAJTextField(""+clientSectionAssignmentCount,20);
		nPanel.add(clientSectionAssignmentCountField);
		getContentPane().add(nPanel);

		JPanel aaPanel = new JPanel();
		aaPanel.setLayout(new GridLayout(0,2));
		aaPanel.add(wmk.makeAJLabel("# of iterations to go"));
		numIterationsField = wmk.makeAJTextField(""+numIterations, 20);
		aaPanel.add(numIterationsField);
		getContentPane().add(aaPanel);		
		
		JPanel aqPanel = new JPanel();
		aqPanel.setLayout(new GridLayout(0,2));
		aqPanel.add(wmk.makeAJLabel("MB allocation for stack->"));
		stackSizeField = wmk.makeAJTextField(""+megabytesForSectionStack,10);
		aqPanel.add(stackSizeField);
		getContentPane().add(aqPanel);		
		
		JPanel sPanel = new JPanel();
		sPanel.setLayout(new GridLayout(0,2));
		sPanel.add(wmk.makeAJButton("start another decon client"));
		pauseButton = wmk.makeAJButton("pause");
		sPanel.add(pauseButton);
		getContentPane().add(sPanel);
		
		JPanel gPanel = new JPanel();
		gPanel.setLayout(new GridLayout(0,2));
		gPanel.add(wmk.makeAJButton("show previous section"));
		gPanel.add(wmk.makeAJButton("show all PSF sections"));
		getContentPane().add(gPanel);

		JPanel bPanel = new JPanel();
		bPanel.setLayout(new GridLayout(0,2));
		bPanel.add(wmk.makeAJButton("show section ->"));
		showSectionField = wmk.makeAJTextField(""+showSection, 20);
		bPanel.add(showSectionField);
		getContentPane().add(bPanel);

		JPanel tPanel = new JPanel();
		tPanel.setLayout(new GridLayout(0,2));
		tPanel.add(wmk.makeAJButton("show next section"));
		saturatedDisplayPixelsField = wmk.makeAJTextField("",25);
		tPanel.add(saturatedDisplayPixelsField);
		getContentPane().add(tPanel);

		JPanel colPanel = new JPanel();
		colPanel.setLayout(new GridLayout(1,5));
		colPanel.add(wmk.makeAJButton(" red"));
		colPanel.add(wmk.makeAJButton("qreen"));
		colPanel.add(wmk.makeAJButton(" blue"));
		colPanel.add(wmk.makeAJButton(" gray"));
		colPanel.add(wmk.makeAJButton("invis"));
		
		JPanel ggPanel = new JPanel();
		ggPanel.setLayout(new GridLayout(0,2));
		origSectColorButton=wmk.makeAJButton("red orig section, or->");
		ggPanel.add(origSectColorButton);
		ggPanel.add(colPanel);
		getContentPane().add(ggPanel);
	
		JPanel coldPanel = new JPanel();
		coldPanel.setLayout(new GridLayout(1,5));
		coldPanel.add(wmk.makeAJButton("red"));
		coldPanel.add(wmk.makeAJButton("green"));
		coldPanel.add(wmk.makeAJButton("blue"));
		coldPanel.add(wmk.makeAJButton("gray"));
		coldPanel.add(wmk.makeAJButton("rgbg"));
		
		JPanel gggPanel = new JPanel();
		gggPanel.setLayout(new GridLayout(0,2));
		deconSectionColorButton=wmk.makeAJButton("green decon section, or-> ");
		gggPanel.add(deconSectionColorButton);
		gggPanel.add(coldPanel);
		getContentPane().add(gggPanel);
	
		JPanel bbPanel = new JPanel();
		bbPanel.setLayout(new GridLayout(0,2));
		bbPanel.add(wmk.makeAJLabel("showSectionScaleFactor="));
		showSectionScaleField = wmk.makeAJTextField(""+trunc(showSectionScale), 20);
		bbPanel.add(showSectionScaleField);
		getContentPane().add(bbPanel);

		JPanel zzPanel = new JPanel();
		zzPanel.setLayout(new GridLayout(0,2));
		lowpassButton = wmk.makeAJButton("lowpass neighbor weight=");
		zzPanel.add(lowpassButton);
		lowpassWeightField = wmk.makeAJTextField(""+lowpassWeight,20);
		zzPanel.add(lowpassWeightField);
		getContentPane().add(zzPanel);

		JPanel rPanel = new JPanel();
		rPanel.setLayout(new GridLayout(0,4));
		rPanel.add(wmk.makeAJButton("nicer"));
		rPanel.add(wmk.makeAJButton("less nice"));
		rPanel.add(wmk.makeAJLabel(" noglow->"));
		noGlowField = wmk.makeAJTextField(""+noglow,10);
		rPanel.add(noGlowField);		
		getContentPane().add(rPanel);

		JPanel cPanel = new JPanel();
		cPanel.setLayout(new GridLayout(0,4));
		cPanel.add(wmk.makeAJLabel("startSection="));
		startSectionField = wmk.makeAJTextField(""+startSection,10);
		cPanel.add(startSectionField);
		cPanel.add(wmk.makeAJLabel("stopSection="));
		stopSectionField = wmk.makeAJTextField(""+stopSection,10);
		cPanel.add(stopSectionField);
		getContentPane().add(cPanel);

		getContentPane().add(wmk.makeAJButton("deconvolve start->stop sections"));
		getContentPane().add(wmk.makeAJButton("tell status of sections now in memory"));
		getContentPane().add(wmk.makeAJButton("stop series of deconvolutions"));
		
		sepukuButton = wmk.makeAJButton("terminate this deconvolution");
		upsideDownButton = wmk.makeAJButton("use PSF cones right side up (toggle)");		
		writeBioradStackButton = wmk.makeAJButton("Write deconvolved sections to Bio-Rad pic file");
				
		getContentPane().add(upsideDownButton);
		getContentPane().add(sepukuButton);
		getContentPane().add(writeBioradStackButton);
		report1Field = wmk.makeAJTextField("watch this space",80);
		getContentPane().add(report1Field);
		report2Field = wmk.makeAJTextField("watch this space also",165);
		getContentPane().add(report2Field);

		wmk = null;
		}
		
	private synchronized int getNumIterationsLeft() {
		 return numIterations;
		}
	
/* when each iteration of deconvolutions starts, the method called markAllSectionsVirgin() sets	ifDeconCalculationDone[k]=0
for k=startSection,...,stopSection. 
code:
ifDeconCalculationDone[i] == 0  meeans section i is in virgin state, neither assigned nor finished
ifDeconCalculationDone[i] == 1  meeans section i is assigned but not yet finished
ifDeconCalculationDone[i] == 2  meeans section i is finished, i.e. its leaksum array has been computed for this iteration.
ifDeconCalculationDone[i] == 3  meeans section i is really finished, i.e. its leaksum array has been computed and its scaled origSect array is 
								cached on disk.

*/ 
	private long timeNow() {
		return (new Date()).getTime()/1000; // returns seconds
		}			
	
	private  synchronized void  markAllSectionsUnassigned() {
		for(int i=startSection;i<=stopSection;i++) {
			ifDeconCalculationDone[i]=0;
			assignmentTimes[i]=-1;
			}
		}
	
	private synchronized int timeSinceAssignment(int sect) {
		if(ifDeconCalculationDone[sect] != 1)
			return -1;
		return (int)(timeNow() - assignmentTimes[sect]);
		}
	
	private synchronized int assignedButLostSection(int tolerableDelay) {
		int since=-1,sectlost=-1;
		for(int i= startSection; i <= stopSection; i++)
			if(timeSinceAssignment(i) > since) {
				sectlost=i;
				since = timeSinceAssignment(i);
				}
		if(since > tolerableDelay && since > 0)
			return sectlost;
		else
			return -1;
		}
			
	private synchronized void markThisSectionAssigned(int k) { // marks section k as finished
		ifDeconCalculationDone[k] = 1;
		assignmentTimes[k] = timeNow();
		}	
		
	private synchronized void markThisSectionDone(int k) { // marks section k as finished
		ifDeconCalculationDone[k] = 2;
		}	
	
	private synchronized void markThisSectionCached(int k) { // marks section k as finished
		ifDeconCalculationDone[k] = 3;
		}	
	
	private synchronized boolean isSectionDoneQ(int k) {
		return (ifDeconCalculationDone[k] >= 2);
		}
		
	private synchronized String stringList(int [] list) { 
		int i;
		String stg="";
		if(list==null) return stg;
		for(i=0;i<list.length;i++) {
			stg = stg+list[i]+", ";
			}
		return stg;
		}

	private synchronized int [] sectionssAwaitingCompletion() {// returns null when all sections have had  their leaksum[] arrays
	// computed. Else returns an int [] array listing  which sections remain undone. 
		int i,imany=0;
		int [] temp = new int[stopSection-startSection+1];
		for(i=startSection;i<=stopSection;i++) 
			if(ifDeconCalculationDone[i]==1) {
				temp[imany]=i;
				++imany;
				}
		if(imany<=0) {
			talk("sectionssAwaitingCompletion() returns null because all the sections have had their leaksum arrays computed");
			logtalk("sectionssAwaitingCompletion() returns null because all the sections have had their leaksum arrays computed");
			return null;
			}
		else {
			int [] retn = new int[imany];
			for(i=0;i<imany;i++)
						retn[i]=temp[i];
			logtalk("sectionsAwaitingCompletion() returns "+stringList(retn));
			return retn;
			}
		}
	
	private synchronized int [] sectionsFinishedButNotCached() {// returns null when all sections have had  their leaksum[] arrays
	// computed. Else returns an int [] array listing  which sections remain undone. 
		int i,imany=0;
		int [] temp = new int[stopSection-startSection+1];
		for(i=startSection;i<=stopSection;i++) 
			if(ifDeconCalculationDone[i]==2) {
				temp[imany]=i;
				++imany;
				}
		if(imany<=0) return null;
		else {
			int [] retn = new int[imany];
			for(i=0;i<imany;i++)
				retn[i]=temp[i];
			logtalk("sectionsFinishedButNotCached() returns "+stringList(retn));
			return retn;
			}
		}
	
	private synchronized int [] unassignedSections() {// returns null when all sections have been assigned
	//  Else returns an int [] array listing which sections remain unassigned. 
		int i,imany=0;
		int [] temp = new int[stopSection-startSection+1];
		for(i=startSection;i<=stopSection;i++) 
			if(ifDeconCalculationDone[i]==0) {
				temp[imany]=i;
				++imany;
				}
		if(imany<=0) return null;
		else {
			int [] retn = new int[imany];
			for(i=0;i<imany;i++)
				retn[i]=temp[i];
			logtalk("unassignedSections() returns "+stringList(retn));
			return retn;
			}
		}
	
	public synchronized boolean areDeconvolutionsInProgress() {	
		if(!deconvolutionsInProgress) {
			// talk(" areDeconvolutionsInProgress() returns false because deconvolutionsInProgress==false");
			return false;
			}	
		if(sectionssAwaitingCompletion() != null) {
			//talk("areDeconvolutionsInProgress() returns true because sectionsAwaitingCompletion() was not null");
			return true;
			}
		else {
			talk("areDeconvolutionsInProgress() just plain returns false"); 
			return false;
			}
		}
		
	private synchronized void startDeconvolutionSequence()  { // call this to start each deconvolution iteration for all sections
	// from number startSction to stopSection.
		talk("startDeconvolutionSequence() reads text fields");
		readTextFields();
		String stg = "do all sections from number "+startSection+" to number "+stopSection;
		talk(stg);
		report1(stg);
		for(int i=startSection;i<=stopSection;i++) {
			SubfacForSubtraction[i]=-1;
			}			
		talk("startDeconvolutionSequence() calls markAllSectionsUnassigned()");
 		markAllSectionsUnassigned();
 		sectBeingDeconvolved=startSection-1;
		if(numSuckers<=0)
			activateAnotherSucker();
		if(DPSF.ifUsingConesUpsideDown()) 
			upsideDownButton.setText("using PSF cones upside down (cannot change)");
		else
			upsideDownButton.setText("using PSF cones right side up (cannot change)");
		talk("startDeconvolutionSequence() seets MasterSwitchState=1");
		MasterSwitchState=1;
		deconvolutionsInProgress = true;
		}		
		
	public synchronized int [] getListOfSectionsToDeconvolve() {
		int [] retn;	
		if(MasterSwitchState != 1) {
			//talk("getListOfSectionsToDeconvolve() returns null because 1 != MasterSwitchState == "+MasterSwitchState);
			return null;
			}
		if(!deconvolutionsInProgress) {
			//talk("getListOfSectionsToDeconvolve() returns null because deconvolutionsInProgress==false");
			logtalk("getListOfSectionsToDeconvolve() returns null because deconvolutionsInProgress==false");
			 return null;
			 }	
		int [] list = unassignedSections();
		
		if(list == null) {
			int lostSect = assignedButLostSection(maxSecs2WaitBeforeReassigning);
			if(lostSect < 0) {// no assigned section has gone more than maxSecs2WaitBeforeReassigning
				//talk("getListOfSectionsToDeconvolve() returns null because list == null and lostSect < 0");
				logtalk("getListOfSectionsToDeconvolve() returns null because list == null and lostSect < 0");
					// second without being returned
				return null;
				}
			retn = new int[2];
			retn[0]=1;
			retn[1]=lostSect;		
			markThisSectionAssigned(lostSect);
			return retn;
			}
				
		int itask = clientSectionAssignmentCount;
		if(list.length < itask)
			itask = list.length;
		retn = new int[itask+1];	
		
		for(int i=0;i<itask;i++) {
			retn[i+1] = list[i];
			markThisSectionAssigned(list[i]);	
			}
				
		retn[0]=itask;
		String stg = "getListOfSectionsToDeconvolve() returns list: "+stringList(retn);
		report1(stg);
		logtalk(stg);
		return retn;
		}
				
	private synchronized  void sectionsGetOlder() {
		if(theSections==null) return;
		for(int i=0;i<sectsInStack;i++)
			if(theSections[i] != null)
				theSections[i].age(true);
		}
				
	private synchronized  void emptyOldestSection() {
		int oldestAge=0,ioldest=-1;
		for(int i=0;i<sectsInStack;i++)
			if(theSections[i] != null && theSections[i].age(false) > oldestAge) {
				oldestAge = theSections[i].age(false);
				ioldest = i;
				}
				// empty the section after cacheing it
		emptyASection(ioldest);
		String sttg = "oldest section "+ioldest+" of age "+oldestAge+" emptied";
		logtalk(sttg); report1(sttg);
		sectionsGetOlder();
		}
				
	private synchronized  void emptyASection(int z) {
		theSections[z].sepuku();
		theSections[z]=null;
		}
		
	private synchronized  void loadSection(int z) {
		sectionsGetOlder();
		String stg;
		if(theSections[z] != null) {
			// talk("loadSection("+z+") finds that section already in memory");
			theSections[z].resetAge(0); // sets age counter to zero
			return;
			}
		// make room to load a new section...
		
		megabytesForSectionStack = (int)(Double.valueOf(stackSizeField.getText()).doubleValue());		
		maxSectionsInRam = (int)((1000000.0*(double)megabytesForSectionStack)/(double)bytesPerLeLiSect);
		while(countSectionsInRam() >= maxSectionsInRam)
			emptyOldestSection();
			
		// load section z
		if(isSectionCachedOnDisk[z] || ifFileExists(sectionFIleNames[z])) {
		 	stg="loadSection("+z+") from disk file = "+sectionFIleNames[z];
			logtalk(stg); report1(stg);
			theSections[z] = new LeakedLight(sectionFIleNames[z],mainParameter);
			}
		else {
			stg="loadSection("+z+") loads that section from the Bio-rad pic file";
			logtalk(stg); report1(stg);
			theSections[z] = new LeakedLight(stackWidth, stackHeight, z, rgbchan, mainParameter, theStack.readBioradFloatRaster(z));
			}
		}
	
	private  synchronized int countSectionsInRam() {
		int sectionsInRam=0;
		for(int i=0;i< sectsInStack;i++)
			if(theSections[i] != null)
				++sectionsInRam;
		return sectionsInRam;
		}
	// methods above here should be synchronized 
		
	public synchronized  void recordLightLeakedFromSection(int deconSectNum,float [] leaksum, int deconSectStatus) {
		if(isSectionDoneQ(deconSectNum)) {
			logtalk("recordLightLeakedFromSection() gets call to record leaksum array for section "+deconSectNum);
			logtalk("but this section already had its leaksum array returned (by some other decon");
			logtalk("client.  So, do nothing.");
			return;
			}
			
		loadSection(deconSectNum);
		theSections[deconSectNum].acceptLeaksum(leaksum,deconSectStatus);
		markThisSectionDone(deconSectNum);
		theSections[deconSectNum].status = 2;
		theSections[deconSectNum].mainParameter = mainParameter;
		
		double SubfacForSubtractionFraction = theSections[deconSectNum].getSubfacForSubtractionFraction(mainParameter);
		talk("Deconvolver.recordLightLeakedFromSection:  fac = "+SubfacForSubtractionFraction+" in recordLightLeakedFromSection() for section "+deconSectNum);
		theSections[deconSectNum].SubfacForSubtractionFraction = SubfacForSubtractionFraction;
		SubfacForSubtraction[deconSectNum] = SubfacForSubtractionFraction;
		cacheSectionOnDisk(deconSectNum);
		 // the processing is finished only when this iteration's sections are
		// but do not do the subtraction yet;
		}
		
	public synchronized void DSDreport(String message, String uniqueTag) {
		// this is where we can keep track of whether all the lightSuckerClients are alive.
		if(DSD==null)
			DSD=new DeconvolutionStatusDisplay(uniqueTag,message);
		else if(DSD.report(uniqueTag,message) == false)
			DSD = new DeconvolutionStatusDisplay(uniqueTag,message,DSD);
		}
		
	private synchronized void writeDeconvolvedSectionsTo8bitBioradPicStack(int itr8,double rescaleFactor) {
		int k;
		long manybytes=0;
		byte [] thebyteraster;
		String stackName;
		boolean if16bit = (theStack.pixel_bit_depth > 8);
		int nbytespersect = if16bit? 2*theStack.width_height : theStack.width_height;
		RandomAccessFile outpic;	
		
		if(itr8>=0)
			stackName = filePrefix+"_"+itr8+"itr8_Stack.pic";
		else
			stackName = filePrefix+"Stack.pic";
		logtalk(" "); logtalk(" "); logtalk(" "); logtalk(" "); 
		if(if16bit) logtalk(stackName+" will be a 16 bit data stack");
		else logtalk(stackName+" will be an 8-bit stack"); 
		
		try{
			outpic = new RandomAccessFile(stackName,"rw");
			outpic.seek(0); // rewind it in case it already exists
			outpic.write(theStack.header); // this writes the standard header for bio-rad pic files.
			manybytes = (theStack.header).length;
			logtalk("The header has "+manybytes+" bytes.");
			logtalk("isValid() = "+theStack.isValid());
			}
		catch (Exception e) {
			talk("openWritingFile("+stackName+") and/or write the header failed");
			return;
			}
		for(k=0;  k < theStack.num_pics;  k++) {
			if(k >= startSection && k <= stopSection) {
				logtalk("HERE COMES DECONVOLVED SECTION "+k);
				loadSection(k); // get the section into the cache, reading it from disk if necessary
				if(rescaleFactor>0.) {
					theSections[k].scaleSection(rescaleFactor);
					cacheSectionOnDisk(theSections[k].secnum);
					sectionsGetOlder();
					theSections[k].resetAge(0);
					markThisSectionCached(k);
					// written to the disk stack;
					}
				thebyteraster = if16bit? theSections[k].getDoubleByteRaster(showSectionScale) : theSections[k].getByteRaster(showSectionScale);
				}
			else { // just use the original section
				logtalk("HERE COMES ORIGINAL, UNPROCESSED SECTION "+k);
				thebyteraster = theStack.readBioradRawByteRaster(k);
				}
					try{Thread.sleep(30);} 
					catch(InterruptedException e) {;} 
			if(thebyteraster != null) {	
				logtalk("section "+k+" is a "+thebyteraster.length+" byte raster");
				try { 
					outpic.seek(nbytespersect*k + (theStack.header).length);
					outpic.write(thebyteraster);
					manybytes += thebyteraster.length;
					}
				catch (IOException e) {
					logtalk("Failure to write section "+k+" to biorad-format pic file.");
					return;
					}
				logtalk("Wrote section "+k+" with "+theStack.pixel_bit_depth+"-bit data");
				}
			else logtalk("thebyteraster for section "+k+" was null");
			}
		
		// now write the trailer. 
		theStack.writeTrailer(outpic, theStack.num_pics);
		logtalk("The bio-rad file has about "+manybytes+" bytes");
		try{ 
		   	outpic.close();
			}
		catch (IOException exc){
		   	logtalk("Trouble closing file:" + exc);
			}
			
		if(if16bit) logtalk(stackName+" will be 16 bit data stack");
		else logtalk(stackName+" will be an 8-bit stack");		
		}
	
	private synchronized double weightFunction(int k) {
		double wings = .5*(DPSF.nSectsUp + DPSF.nSectsDown);
		double upramp = (k-startSection)/wings;
		double downramp = (stopSection-k)/wings;
		if(upramp > downramp) 
			upramp = downramp;
		if(upramp >=1) return 1.0;
		return (0.1 + .9*upramp);
		}
			
	private synchronized double actuallySubtractLightFromAllDeconvolvedSections() {
		float [] rawSect;
		double AA=0.  ,BB=0.  ,CC=0.  ,boostFac=0., alphaOpt,leastSquareError,boostDenom;
		double [] ABC;
		int k,navg=0;
		// get the average value of SubfacForSubtractionFraction
		double SubfacForSubtractionFraction = 0, darkMatterFrac, avgDarkMatterFrac, uk;

		logtalk("******************Start in actuallySubtractLightFromAllDeconvolvedSections()");
		
		for(k=startSection;k<= stopSection;k++) 
			if( isSectionDoneQ(k)) {
				SubfacForSubtractionFraction += SubfacForSubtraction[k];
				++navg;
				}
			else {
				logtalk("Something is terribly wrong. actuallySubtractLightFromAllDeconvolvedSections() finds");
				logtalk("isSectionDoneQ"+k+") = "+isSectionDoneQ(k)+" when it should be == true");
				}
		SubfacForSubtractionFraction = SubfacForSubtractionFraction/(navg);
		String stg = "The average value (across sections "+startSection+" to "+stopSection+") is SubfacForSubtractionFraction = "+
				SubfacForSubtractionFraction;
		logtalk(stg);
		report1(stg);
		
		navg=0;
		avgDarkMatterFrac=0.;
		boostDenom = 0;
		logtalk("******************in actuallySubtractLightFromAllDeconvolvedSections() go through all sections to compute subFrac & scaling coeffs");
		for(k=startSection;k<= stopSection;k++) {
			loadSection(k);
					try{Thread.sleep(30);} 
					catch(InterruptedException e) {;} 
			uk = weightFunction(k);
			theSections[k].mainParameter = mainParameter;
			if(theSections[k].status == 2) {
				darkMatterFrac = theSections[k].subtractLeakedLightFromSection(SubfacForSubtractionFraction);
				avgDarkMatterFrac += darkMatterFrac;
				talk("darkMatterFrac = "+trunc(darkMatterFrac)+" in actuallySubtractLightFromAllDeconvolvedSections() for section "+k);
				theSections[k].SubfacForSubtractionFraction = SubfacForSubtractionFraction;					
				theSections[k].status = 3;
				talk("   actuallySubtractLightFromAllDeconvolvedSections() sets status == 3 for section "+k);		
				if(ifLowpassFilter) 
					theSections[k].lowPassFilter(lowpassWeight);	
				// now compute the error coeffs for this section.
				rawSect = theStack.readBioradFloatRaster(k);
					
				ABC = theSections[k].computeErrorContributionCoeffs(rawSect);	 
				AA += uk*ABC[0];	 
				BB += uk*ABC[1];
				CC += uk*ABC[2];
				boostFac += uk*ABC[3];
				boostDenom += uk;
				
				talk(""+theSections[k].incrementIterationCounter()+" deconvolution iterations done on section "+k);
				// archive section to disk;
				cacheSectionOnDisk(theSections[k].secnum);
				sectionsGetOlder();
				theSections[k].resetAge(0);
				++navg;
				}
			else {
				logtalk("Something is seriously wrong. actuallySubtractLightFromAllDeconvolvedSections() finds");
				logtalk("for section "+k+", status = "+theSections[k].status+" when it should be == 2");
				}
			}
		avgDarkMatterFrac = avgDarkMatterFrac/navg;
		String sss = "The average value of darkMatterFrac came out to be "+avgDarkMatterFrac;
		talk(sss); 	
		report1(sss);	
		// get alphaOpt;
		alphaOpt = AA/BB;
		leastSquareError = Math.sqrt((CC  -  AA*AA/BB)/(double)(boostDenom*theStack.width_height));
		boostFac = boostFac/boostDenom;	
		talk("");
		sss = "boostFac="+doubleString(boostFac)+", alpha= "+doubleString(alphaOpt)+", rootMeanSquaredError/pix="+doubleString(leastSquareError);
		DSDreport(sss, ("pass "+iterationsDone) );
		sss = "Pass "+iterationsDone+": "+sss;
		talk(sss); 	report1(sss);	
		if(IterationErrorLogFIle==null) { // open the log file and leave it open
			String logfilename = filePrefix+"IterationLogFile.txt";
			try{
				IterationErrorLogFIle = new RandomAccessFile(logfilename,"rw");
				IterationErrorLogFIle.seek(0); // rewind it in case it already exists
				}
			catch (Exception e) {
				logtalk("openWritingFile("+logfilename+") failed with this exception "+e);
				}
			} 
				
		writeAString(sss,IterationErrorLogFIle);
		
		// measure trend of leastSquareError
		if(trend<=0) { // error was going down
			if(leastSquareError <= lastRootMeanSquaredErrorPerpix)
				--trend;
			else
				trend = 1; // flag that error is now increasing
			}
		else { // error was going up. If it keeps going up, terminate the process from the main run loop.
			if(leastSquareError > lastRootMeanSquaredErrorPerpix)
				++trend;
			else
				trend = 0; // flag that error is now increasing
			}
		lastRootMeanSquaredErrorPerpix = leastSquareError;
			
		
		writeAString(("   this came from AA="+doubleString(AA)+", BB="+doubleString(BB)+", CC= "+doubleString(CC)),IterationErrorLogFIle);		
		 writeAString("   per-iteration removal fraction = "+mainParameter,IterationErrorLogFIle);
		 writeAString("   low pass weight = "+lowpassWeight,IterationErrorLogFIle);
		 writeAString("   noglow = "+noglow,IterationErrorLogFIle);
		writeAString("  ",IterationErrorLogFIle);
			
		return boostFac;
		}

	private synchronized String doubleString(double dbl) {
		String stg = ""+dbl;
		int i = stg.indexOf(".");
		if(i>=0) {
			i +=5;
			return (stg.substring(0,i));
			}
		return stg;
		}
		
	private synchronized void writeAString(String stg,RandomAccessFile outf) {
		byte [] buf = new byte[stg.length()+1];
		if(outf != null) {
			stg.getBytes(0,stg.length(),buf,0);
			buf[stg.length()] = 10;
				try {
				outf.write(buf);
				}
			catch (IOException ioex) {
				logtalk("writeAString to file failed: "+ioex);
				}
			}
		}		
	
	public synchronized int [] getSectionParams(int whichSection) {
		sectionsGetOlder();
		loadSection(whichSection);
		int [] retn = new int[6];
		retn[0] = theSections[whichSection].raswidth;
		retn[1] = theSections[whichSection].rasheight;
		retn[2] = theSections[whichSection].rgbchan;
		retn[3] = theSections[whichSection].numDeconvolutionIterations;
		retn[4] = theSections[whichSection].secnum;
		retn[5] = theSections[whichSection].status;
		return retn;
		}
				
	public synchronized void copyOrigSect(int whichSection, float [] os)	 {  // os must come preallocated with the right size
		// this is used by the client LightSuckerClient() threads
		loadSection(whichSection); 
		int npix = theSections[whichSection].npix;
		for(int i=0; i<npix;i++)
			os[i] = theSections[whichSection].origSect[i];
		sectionsGetOlder();
		theSections[whichSection].resetAge(0);
		}
		
	public synchronized void copyLeaksum(int whichSection, float [] ls)	 {
		loadSection(whichSection); // ls must come preallocated with the right size
		int npix = theSections[whichSection].npix;
		if(theSections[whichSection].status>0)
			for(int i=0; i<npix;i++)
				ls[i] = theSections[whichSection].leaksum[i];
		else 
			for(int i=0; i<npix;i++)
				ls[i] = 0;
		sectionsGetOlder();
		theSections[whichSection].resetAge(0);
		}
		
	private synchronized void displayPSF_Blurs() {
		if(pictureDisplay == null)
		  		pictureDisplay = new showDeconJFrame(stackWidth,stackHeight, 0, this);	
		pictureDisplay.newPic(0,DPSF.getBlursRaster(stackWidth,stackHeight),deconSectionColor,
		  		DPSF.getGridRaster(stackWidth,stackHeight),origSectColor);
		}
	
	private synchronized void incrementDisplaySection(int incr) {
		readTextFields();
		showSection += incr;
		if(showSection<0) showSection=0;
		if(showSection>=sectsInStack) showSection=sectsInStack-1;	
		showSectionField.setText((""+showSection));			
		displaySection(showSection);
		}
				
	private synchronized void displaySection(int iz) {
		picJPanel.gotosection(iz); // show the original section
		if(theSections[iz]==null)
			loadSection(iz);			
		if(pictureDisplay == null)
		  	pictureDisplay = new showDeconJFrame(stackWidth,stackHeight, iz, this);	
		
		byte [] rawDataSection = theStack.readBioradRaster(iz); 
		byte [] convolvedSection = (theSections[iz].status == 1 || theSections[iz].status ==2)? 
					theSections[iz].getByteRaster(showSectionScale, rawDataSection) : theSections[iz].getByteRaster(showSectionScale);	
		int numSaturatedPixels = pictureDisplay.newPic(iz,convolvedSection, deconSectionColor, rawDataSection, origSectColor);
			
		saturatedDisplayPixelsField.setText(""+numSaturatedPixels+" saturated pixels");
		sectionsGetOlder();
		String stg="show section "+iz;
		report1(stg);
		logtalk(stg);
		theSections[iz].resetAge(0);
		}	
	
	private synchronized void readTextFields() {
		mainParameter = Double.valueOf(mainParameterField.getText()).doubleValue();
		if(mainParameter<0) mainParameter=0;
		if(mainParameter>1.0) mainParameter=1.0;	
		mainParameterField.setText((""+mainParameter));
		
		clientSectionAssignmentCount = (int)(Double.valueOf(clientSectionAssignmentCountField.getText()).doubleValue());
		if(clientSectionAssignmentCount<1) clientSectionAssignmentCount=1;
		if(clientSectionAssignmentCount>=25) clientSectionAssignmentCount=25;	
		clientSectionAssignmentCountField.setText((""+clientSectionAssignmentCount));
		
		numIterations = (int)(Double.valueOf(numIterationsField.getText()).doubleValue());
		if(numIterations<1) numIterations=0;
		if(numIterations>=48) numIterations=48;	
		numIterationsField.setText((""+numIterations));
		
		lowpassWeight = Double.valueOf(lowpassWeightField.getText()).doubleValue();
		if(lowpassWeight<0) lowpassWeight=0;
		if(lowpassWeight>=1.) lowpassWeight = 1.;	
		lowpassWeightField.setText((""+trunc(lowpassWeight)));
		
		if(!areDeconvolutionsInProgress()) {
			startSection = (int)(Double.valueOf(startSectionField.getText()).doubleValue());
			if(startSection<0) startSection=0;
			if(startSection>=sectsInStack-1) startSection = sectsInStack-2;	
					
			stopSection = (int)(Double.valueOf(stopSectionField.getText()).doubleValue());
			if(stopSection<0) stopSection=0;
			if(stopSection>=sectsInStack) stopSection = sectsInStack-1;	
		
			if(startSection > stopSection)
				startSection=stopSection;
			startSectionField.setText((""+startSection));	
			stopSectionField.setText((""+stopSection));	
			}
		
		showSection = (int)(Double.valueOf(showSectionField.getText()).doubleValue());
		if(showSection<0) showSection=0;
		if(showSection>=sectsInStack) showSection=sectsInStack-1;	
		showSectionField.setText((""+showSection));			
		
		showSectionScale = Double.valueOf(showSectionScaleField.getText()).doubleValue();
		if(showSectionScale<0) showSectionScale=0;
		if(showSectionScale>=4.) showSectionScale=4.0;	
		showSectionScaleField.setText((""+trunc(showSectionScale)));	
		getNoGlow();
		megabytesForSectionStack = (int)(Double.valueOf(stackSizeField.getText()).doubleValue());		
		}
		
	public synchronized double getNoGlow() {
		noglow = Double.valueOf(noGlowField.getText()).doubleValue();
		if(noglow < .01) noglow=.01;
		if(noglow > 10) noglow=10;
		noGlowField.setText(""+noglow);		
		return noglow;
		}
			
	public void sepuku() {
		logtalk("Terminating this deconvolver.");
		report1("Terminating this deconvolver.");
		File afile;
		int i;
		
		if(DSD != null)
			DSD.sepuku();
		LSCI.sepuku();					

		for(i=0;i<numSuckers;i++) {
			if(suckers[i] != null)
				suckers[i].sepuku();
			suckers[i]=null;
			}
		numSuckers=0;	
		for(i=0; i<sectsInStack; i++) 
			if(theSections[i] != null) { 
				theSections[i].sepuku();
				isSectionCachedOnDisk[i]=false;
				theSections[i] = null;
				}
		if(SDSS != null)
			SDSS.sepuku();
		afile=null;
		isSectionCachedOnDisk=null;
		theSections = null;
		DPSF=null;
		sectionFIleNames = null;
		theStack=null;
		picJPanel.parent.decon = null;	
		mainParameterField = null;	

		numIterationsField = null;	
		startSectionField = null;	
		if(pictureDisplay != null)
			pictureDisplay.sepuku();
		dispose();
		}
	
	public synchronized void report1(String stg) {
		report1Field.setText(stg);
		}
		
	public synchronized void report2(String stg) {
		String sss = stg+' '+rep2string;
		int len = sss.length();
		if(len > 164) len=164;
		rep2string = sss.substring(0,len);		
		report2Field.setText(rep2string);
		}
	
	public void start() {
		if(deconThread==null) 
			deconThread=new Thread(this);
		deconThread.start();
		}
			
	public void stop() {
		if(deconThread != null) 
			deconThread.stop();
		deconThread=null;
		}
			
	public void run() {
		int mstate=0;
		String stg;
		while(true) {
			try{ Thread.sleep(2312);}
			catch(InterruptedException e) {;}
			mstate = MasterSwitchState;
		
			switch (mstate) {
			case 0:
				talk("                           run(): finds                        nothing happening");
				break;
				
			case 1: 
				if(areDeconvolutionsInProgress()) {
					talk("                           run(): finds DeconvolutionsInProgress() == true; remain in state 1");
					break;
					}
				// see if all sections are done
				int [] undone = sectionssAwaitingCompletion();
				if(undone != null) {
					stg = "run() finds these sections remain undone: "+stringList(undone);
					talk(stg);
					report1(stg);
					talk("                           run(): remain in state 1"); 
					break;
					}
			
				
				// We just completed one iteration of deconvolutions.
				// so now actually subtract the leaked light from each section.
				talk("                           run(): advances MasterStateSwitch to 2"); 
				MasterSwitchState=2;
				break;
				
			case 2 :
				MasterSwitchState=3;
				talk("                           run(): advances MasterStateSwitch to 3"); 
				--numIterations; // maybe there is another iteration to go
				numIterationsField.setText((""+numIterations)); // announce decrement in numIterations
				++iterationsDone;
				SDSS.showHeadline("working on iteration number "+(1+iterationsDone));
				talk("                           run(): calls actuallySubtractLightFromAllDeconvolvedSections()"); 
				masterRescaleFactor = actuallySubtractLightFromAllDeconvolvedSections();
				MasterSwitchState=4;
				talk("                           run(): advances MasterStateSwitch to 4"); 
				break;
		
			case 4: 	
				MasterSwitchState=5;
				talk("                           run(): advances MasterStateSwitch to 5"); 						
		  		// write the deconvolved sections into 8-bit and 16-bit biorad stack pics.
		  		talk("                           run(): calls Calls writeDeconvolvedSectionsTo8bitBioradPicStack()"); 
		  		writeDeconvolvedSectionsTo8bitBioradPicStack(iterationsDone,masterRescaleFactor);
		  		// that writes the whole stack for later recovery and possible use
				MasterSwitchState=6;
				talk("                           run(): advances MasterStateSwitch to 6"); 						
				break;
	 
			case 6: 	// previous iteration is complete
			// are there any more iterations to go
		  		if(getNumIterationsLeft() <= 0 || trend > 2) { // nope. We're all done
					logtalk(" run(), We are finished with all iterations *******************************************");
					deconvolutionsInProgress=false;
					sectBeingDeconvolved=7777;
					markAllSectionsUnassigned();
					// close the error log file
					if(IterationErrorLogFIle != null) try {
						IterationErrorLogFIle.close();
						IterationErrorLogFIle = null;
						}
					catch(Exception e) {
						talk("Exception trying to close the file");
						}
					MasterSwitchState=77; // flags completion of everything
					if(trend > 2) stg = "                               run: advances MasterStateSwitch to 77; game over because error is increasing";
					else stg = "                               run: advances MasterStateSwitch to 77; game over because we exceeded max number of iterations allowed";
					talk(stg);     talk(stg);     talk(stg);     talk(stg);     talk(stg);     talk(stg);     						
					break;
					} 
		  		else {//  there are more iterations to do...
					talk("                           run(): initiating anoter iteration by calling startDeconvolutionSequence()"); 						
					startDeconvolutionSequence();  //  setup for next iteration
					// that sets MasterStateSwitch==1 and sets masterSwitchStateAdvancerBusy = false; 						
					break;
					}
				case 77: // game over
					talk("                           run(): the game is over. Stop run() thread.");
					stop();
					break;
					
				default : // should never happen
					talk("                           run(): finds masterStateSwitch == "+MasterSwitchState+"! IMPOSSIBLE!"); 						
		  			break;
		  		}
		
			replaceDeadSuckersWithLiveOnes();
			}
		}
		
	public  boolean isGameOver() {
		return (MasterSwitchState==77);
		}

	private void trippleReport(String stg) {
		talk(stg);
		report1(stg);
		report2(stg);
		}
			
	private boolean OK2startQ() {
		if(!ifChanPicked) 
			trippleReport("You must first pick the channel to be deconvolved.");
		return (ifChanPicked);
		}
		
	 private synchronized void setNewChannel() {
 		int i,zsect; // controls what run() does 
		RandomAccessFile outfile;
		FileDialog getFileToWrite = 
		   		new FileDialog(this,"make file in directory to hold gemporary disk cache files", FileDialog.SAVE);
		getFileToWrite.show();
		fileDirectory = getFileToWrite.getDirectory()+"/";
		getFileToWrite=null;
		switch(rgbchan) {
				case 0:
				default:
					setTitle("deconvolve red channel");
					trippleReport("deconvolve red channel");
					theStack = picJPanel.redfile;
					filePrefix = fileDirectory+"redsect";
					break;
						
				case 1:
					setTitle("deconvolve green channel");
					trippleReport("deconvolve green channel");
					theStack = picJPanel.greenfile;
					filePrefix = fileDirectory+"greensect";
					break;
					
				case 2:
					setTitle("deconvolve blue channel");
					trippleReport("deconvolve blue channel");
					theStack = picJPanel.bluefile;
					filePrefix = fileDirectory+"bluesect";
					break;
				}
			ifChanPicked = true;	
			sectsInStack = theStack.num_pics;
			stopSection = sectsInStack-1;
			stopSectionField.setText((""+stopSection));	

			stackWidth = theStack.width;
			stackHeight = theStack.height;
			bytesPerLeLiSect = 2*stackWidth*stackHeight*4; // *4 because we use floats for each voxel
			
			dxy = theStack.dxy;
			dz = theStack.dz;
			DPSF.fillRasters(dxy, dz); // reset the PSF for the voxel size of this stack
			theSections = new LeakedLight[sectsInStack];
			isSectionCachedOnDisk = new boolean[sectsInStack];
			ifDeconCalculationDone = new int[sectsInStack];	
			assignmentTimes = new long[sectsInStack];		
			SubfacForSubtraction = new double[sectsInStack];
			sectionFIleNames = new String[sectsInStack];
			for(i=0;i<sectsInStack;i++) {
				theSections[i]=null; // null value is a flag that section is not loaded now
				isSectionCachedOnDisk[i]=false;
				sectionFIleNames[i] =filePrefix+i; // these never change
				SubfacForSubtraction[i]=-1.;
				}
			if(SDSS != null)
				SDSS.sepuku();
			SDSS = new ShowDeconSectionStatus(sectsInStack);
			talk("There are "+sectsInStack+" sections in stack number "+rgbchan);		
	 	}	
				
				
	public void statusReport(String stg) {
		if(SDSS == null) return;
		SDSS.report(stg,startSection,stopSection,ifDeconCalculationDone);
		}
		
	private synchronized void activateAnotherSucker() {
		if(LSCI==null) {
			talk(" ");talk(" ");
			talk("Deconvolver.activateAnotherSucker() creates the LSCI = new LightSuckerClientInterface(this)");
			talk(" ");talk(" ");
			LSCI = new LightSuckerClientInterface(this);
			}
		if(numSuckers<maxNumberOfSuckers) {
			suckers[numSuckers] = new LightSuckerClient(LSCI, ("ID"+numSuckers));	
			++numSuckers;
			}
		}

	private synchronized void replaceDeadSuckersWithLiveOnes() {
		int i,rebirths=0,oldest=-1, ioldest=-1, howLongSleeping;
		String idstring;
		for(i=0;i<numSuckers;i++) 
			if(suckers[i] != null && DSD != null) {
				howLongSleeping = (int)(DSD.secsSinceLastReport(("ID"+i)));
				if(howLongSleeping>oldest) {
					oldest = howLongSleeping;
					ioldest = i;
					}
				if(howLongSleeping > 320) { // no word for four minutes. kill it. replace it.
						talk("XXXXXXXXXXXXXXXXXXXXXXx  kill off sucker[+"+i+"]. It's been OTL for "+howLongSleeping+" seconds");
						DSD.killOff(("ID"+i));
						suckers[i].sepuku();
						suckers[i] = null;
						// start a new one to replace the one that died.
						++rebirths;
						}
					}
		if(oldest>2)
			logtalk("tardiest sucker is number "+ioldest+" which has not reported for "+oldest+" seconds");		
		if(rebirths>0) 
			for(i=0;i<10;i++)
				talk("****************Making "+rebirths+" new light suckers to replace ones that died");
				
		while(rebirths>0) {
			--rebirths;
			activateAnotherSucker();
			}
		}
					
	private synchronized boolean ifFileExists(String filename) {
		File afile = new File(filename);
		boolean ifex = afile.exists();
		afile=null;
		return ifex;
		}
		
			
	private synchronized boolean cacheSectionOnDisk(int z) {
		sectionsGetOlder();
		// returns true if it works
		if(theSections[z]==null) {
			logtalk("Section "+z+" is null. Cannot cache on disk");
			return false;
			}
		else if (isSectionCachedOnDisk==null) return false;
		else {
			String stg="writing section "+z+" to disk";
			talk(stg); report1(stg);
			isSectionCachedOnDisk[z] = theSections[z].writeSectToDisk(sectionFIleNames[z]);
			return isSectionCachedOnDisk[z];
			}
		}
		
	public synchronized float[] getSectionData(int z) {
		if(z<0 || z>= sectsInStack) {
			logtalk("Bad section="+z+" request. Return null");
			return null;
			}
		if(theSections[z] == null) 
			loadSection(z);
		sectionsGetOlder();
		theSections[z].resetAge(0);
		return theSections[z].origSect;
		}
	

// catch WindowListener events  
	public void windowActivated(java.awt.event.WindowEvent event) {
		// talk("window activated");
		}
	public void windowDeactivated(java.awt.event.WindowEvent event) {
		//  talk("window Deactivated");
		}
	public void windowOpened(java.awt.event.WindowEvent event) {}
	public void windowIconified(java.awt.event.WindowEvent event) {}
	public void windowDeiconified(java.awt.event.WindowEvent event) {}
	public void windowClosing(java.awt.event.WindowEvent event) {
	    setVisible(false);
		}
	public void windowClosed(java.awt.event.WindowEvent event) {
		}	 

// catch button and menu events...
	public synchronized void actionPerformed(java.awt.event.ActionEvent event) {
		String arg = event.getActionCommand(),stg;
		int i;

		if(DSD != null) DSD.setVisible(true);
		
		sectionsGetOlder();
		if(arg.equals("REALLY? kill it.") ) {
			sepuku();
			return;
			}
		else
			sepukuButton.setText("terminate this deconvolution");		
			

		if(arg.equals("REALLY Write deconvolved sections to Bio-Rad pic file") ) {
				writeBioradStackButton.setText("Write deconvolved sections to Bio-Rad pic file");
				writeDeconvolvedSectionsTo8bitBioradPicStack(-1,-1.00);
				return;
				}
		else	
			writeBioradStackButton.setText("Write deconvolved sections to Bio-Rad pic file");	
				
		if(OK2startQ() && arg.equals("Write deconvolved sections to Bio-Rad pic file") ) {
			writeBioradStackButton.setText("REALLY Write deconvolved sections to Bio-Rad pic file");	
			return;
			}	

		if(arg.equals("red channel deconvolution") ) {
			chanButton.setText("green channel deconvolution");
			rgbchan=1;
			return;
			}
				
		if(arg.equals("green channel deconvolution") ) {
			chanButton.setText("blue channel deconvolution");
			rgbchan=2;
			return;
			}
				
		if(arg.equals("blue channel deconvolution") ) {
			chanButton.setText("red channel deconvolution");
			rgbchan=0;
			return;
			}
				
			
		if(arg.equals("push after picking channel ->") ) {
			setNewChannel();
			switch (rgbchan) {
				case 0:
				default :
					whichStackButton.setText("deconvolving the red channel");
					break;
				case 1:
					whichStackButton.setText("deconvolving the green channel");
					break;
				case 2:
					whichStackButton.setText("deconvolving the blue channel");
					break;
				}
			return; 
			}
					
		if(OK2startQ() && arg.equals("pause") ) {
			readTextFields();
			pauseButton.setText("resume");
			ifPaused = true;
			return; 
			}
		
				
		if(arg.equals("use PSF cones right side up (toggle)") || arg.equals("use PSF cones upside down (toggle)")) {
			if(DPSF.flipPSFCones())
				upsideDownButton.setText("use PSF cones upside down (toggle)");
			else
				upsideDownButton.setText("use PSF cones right side up (toggle)");;
			return; 
			}
		
		if(arg.equals("nicer") ) {
			++nicesleep;
			report1("nicesleep boosted to "+nicesleep);
			return; 
			}
			
		if(arg.equals("less nice") ) {
			if(--nicesleep <0) nicesleep=0;
			report1("nicesleep cut to "+nicesleep);
			return; 
			}

		if(arg.equals("resume") ) {
			pauseButton.setText("pause");
			readTextFields();
			ifPaused = false;
			return; 
			}
			
		if(arg.equals("lowpass neighbor weight=") ) {
			lowpassButton.setText("no low pass filtering");
			readTextFields();
			ifLowpassFilter = false;
			return; 
			}
			
		if(arg.equals("no low pass filtering") ) {
			readTextFields();
			lowpassButton.setText("lowpass neighbor weight=");
			ifLowpassFilter = true;
			return; 
			}
			
		if(OK2startQ() && arg.equals("start another decon client") ) {
			readTextFields();
			stg ="Activate another decon client";
			logtalk(stg); report1(stg);
			activateAnotherSucker();
			return; 
			}
			

		if(arg.equals("terminate this deconvolution") ) {
			sepukuButton.setText("REALLY? kill it.");
			return; // we want this to be hard to do
			}
			
		if(OK2startQ() && arg.equals("show section ->") ) {
				incrementDisplaySection(0);
				return;
				}
						
		if(OK2startQ() && arg.equals("show next section") ) {
				incrementDisplaySection(1);
				return;
				}
				
		if(OK2startQ() && arg.equals("show previous section") ) {
				incrementDisplaySection(-1);
				return;
				}
				
		if(OK2startQ() && arg.equals("show all PSF sections")) {
			readTextFields();
			stg ="show all PSF sections";
			logtalk(stg); report1(stg);
				displayPSF_Blurs();
				return;
				}
				
		if(OK2startQ() && arg.equals("stop series of deconvolutions") ) {
				readTextFields();
				stg ="stop series of deconvolutions";
				logtalk(stg); report1(stg);
				deconvolutionsInProgress=false;
				return;
				}
		
		if(OK2startQ() && arg.equals("deconvolve start->stop sections") ) {
			readTextFields();
			if(areDeconvolutionsInProgress()) {
				stg ="A deconvolution series is currently in progress. Wait until it is done.";
				logtalk(stg); report1(stg);
				logtalk("startSection = "+startSection+", and stopSection = "+stopSection);
				return;
				}
			iterationsDone=0;
			startDeconvolutionSequence();
			return;
			}
			
		if(OK2startQ() && arg.equals("tell status of sections now in memory") ) {
				stg = "tell status of sections now in memory";
				logtalk(stg); report1(stg);
				tellStatusOfActiveSections();
				return;
				}

		if(arg.equals(" red") ) {
				readTextFields();
				origSectColor=0;
				origSectColorButton.setText("red orig section, or->");
				return;
				}
		if(arg.equals("qreen") ) {
				origSectColor=1;
				origSectColorButton.setText("green orig section, or->");
				return;
				}
		if(arg.equals(" blue") ) {
				origSectColor=2;
				readTextFields();
				origSectColorButton.setText("blue orig section, or->");
				return;
				}
		if(arg.equals(" gray") ) {
				origSectColor=3;
				readTextFields();
				origSectColorButton.setText("gray orig section, or->");
				return;
				}
		if(arg.equals("invis") ) {
				readTextFields();
				origSectColor=-1;
				origSectColorButton.setText("invis orig section, or->");
				return;
				}

		if(arg.equals("red") ) {
				readTextFields();
				deconSectionColor=0;
				deconSectionColorButton.setText("red decon section, or->");
				return;
				}
		if(arg.equals("green") ) {
				deconSectionColor=1;
				deconSectionColorButton.setText("green decon section, or->");
				return;
				}
		if(arg.equals("blue") ) {
				deconSectionColor=2;
				readTextFields();
				deconSectionColorButton.setText("blue decon section, or->");
				return;
				}
		if(arg.equals("gray") ) {
				deconSectionColor=3;
				readTextFields();
				deconSectionColorButton.setText("gray decon section, or->");
				return;
				}
	}
		
	private  synchronized void tellStatusOfActiveSections() {
		for(int i=0;i< sectsInStack; i++)
			if(theSections[i] != null)
				logtalk(theSections[i].statusReport());
		}

			
	public synchronized String  trunc(double num) {
		// example num = -1023.1234567
		String stg = num <0.? "-" : ""; // stg = "-"
		num = Math.abs(num); // 1023.1234567
		int integralPart = (int)num; // 1023
		double remainder = num - integralPart; // 0.1234567
		int fourRemDigits = (int)(10000.*remainder); // 1234
		if(fourRemDigits==0) return (stg+integralPart+".0000");
		else if(fourRemDigits < 10)    return (stg+integralPart+".000"+fourRemDigits);
		else if(fourRemDigits < 100)   return (stg+integralPart+".00"+fourRemDigits);
		else if(fourRemDigits < 1000)  return (stg+integralPart+".0"+fourRemDigits);
		else return (stg+integralPart+"."+fourRemDigits);
		}
		
	static  synchronized void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}
		
	public  synchronized void logtalk(String stg) { // write a line on the error logfile.
		if(logfile==null) {
			try{
				logfile = new RandomAccessFile("/tmp/deconvolverlog","rw");
				logfile.seek(0); 
				}
			catch (Exception e) {
				talk("open /tmp/deconvolverlog failed");
				return;
				}
			}
		writeAString(stg, logfile);
		}
}