package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.io.*;
import java.lang.*;
import java.util.*;
import java.awt.*;  import javax.swing.*;


class IfUseSqrtTransform extends JFrame implements java.awt.event.ActionListener,java.awt.event.WindowListener {
	ShowPicJPanel picJPanel;
	int nomwidth=300,nomheight=40;
	boolean ifUseSqrtTransformFor16BitData = false;
	JButton useSqrtButton;
	
    public IfUseSqrtTransform(ShowPicJPanel picJPanel) {   
    super("Use Sqrt Transform?");
    this.picJPanel = picJPanel;
    WidgetMaker wmk = new WidgetMaker(this);
    getContentPane().setLayout(new GridLayout()); 
    setSize(nomwidth, nomheight);
    useSqrtButton = wmk.makeAJButton("Using high 8 bits of 16-bit data");
	getContentPane().add(useSqrtButton);
	addWindowListener(this);
	setLocation(200,500);
	setVisible(true);
  	}

// catch WindowListener events  
	public void windowActivated(java.awt.event.WindowEvent event) {
		// talk("window activated");
		}
	public void windowDeactivated(java.awt.event.WindowEvent event) {
		//  talk("window Deactivated");
		}
	public void windowOpened(java.awt.event.WindowEvent event) {}
	public void windowIconified(java.awt.event.WindowEvent event) {}
	public void windowDeiconified(java.awt.event.WindowEvent event) {}
	public void windowClosing(java.awt.event.WindowEvent event) {
	    setVisible(false);
		}
	public void windowClosed(java.awt.event.WindowEvent event) {
		}
	 
// catch button and menu events...
	public void actionPerformed(java.awt.event.ActionEvent event) {
		String arg = event.getActionCommand();
    	JTextField sect;
    	
	    if(arg.equals("Using high 8 bits of 16-bit data")) {
			ifUseSqrtTransformFor16BitData=true; 
			useSqrtButton.setText("Using sqrt transform on 16-bit data");
    		}
	    if(arg.equals("Using sqrt transform on 16-bit data")) {
			ifUseSqrtTransformFor16BitData=false; 
			useSqrtButton.setText("Using high 8 bits of 16-bit data");
    		}
    	picJPanel.useSqrtTransform(ifUseSqrtTransformFor16BitData);
		}


	public void changeJPanelSize(double ratio) {
		int pwidth = getSize().width;
		int pheight = getSize().height;
		pwidth = (int)(ratio*pwidth +.4999);
		pheight = (int)(ratio*pheight +.4999);
		setSize(pwidth,pheight);
		show();
		}

	static void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}
}

