package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.*;  import javax.swing.*;


import java.awt.image.*;
import java.io.*;
import java.net.*;
import java.lang.*;
import java.util.*;


class ShowPicJPanel extends JPanel implements DialogCallback, Runnable, java.awt.event.MouseListener,java.awt.event.MouseMotionListener,java.awt.event.KeyListener
  {	
  	boolean ifMakingMask = false;
  	// change next line to locate where vefFire0 is
  	String whereIsVefFire0 = "../";
 	// the run thread is for writing the each section in the whole stack to disk files as
 	// color pictures later to be made into a quicktime movie. 
	Font alp = new Font("application",Font.PLAIN,9);
	JPanel topJBar;
	boolean  ifdiags=false;
	int sectionType=0;
	boolean ifWebStacks=false;
	boolean ifWriteWebfiles = false;
	final static int GOTO_SLICE_DLOG = 2;
	final static int MOUSE_PICKS_A_MARK = 10;
	final static int MOUSE_MOVES_SELECTED_MARK = 11;
	final static int MOUSE_REPORTS_LOCATION_COLORS = 12;
	final static int MOUSE_MOVES_RED_SELECTED_LEAF = 18;
	final static int MOUSE_MOVES_GREEN_SELECTED_LEAF = 19;
	final static int MOUSE_MOVES_BLUE_SELECTED_LEAF = 20;
	final static int MOUSE_PICKS_MEASURE_MARK_1 = 21;
	final static int MOUSE_PICKS_MEASURE_MARK_2 = 22;
	final static int MOUSE_MOVES_OUTERBOX_CENTER = 23;
	final static int MOUSE_MOVES_INNERBOX_CENTER = 26;
	final static int MOUSE_CLICKS_DEFINE_POLYGON = 24;	
	final static int MOUSE_DRAGS_POLYGON_VERTEX = 25;	
	final static int MOUSE_CLICKS_DEFINE_TRANSECT = 28;	
	final static int MOUSE_DRAGS_TRANSECT_VERTEX = 29;	
	final static int MOUSE_MOVES_TRANSECT_CENTER = 27;
	
	final static int PICK_NEAREST_CENT = 70;
	final static int MOVE_SELECTED_CENT = 71;
	final static int ADD_NEW_CENT = 72;
	final static int PICK_NEAREST_HOLE = 73;
	final static int MOVE_SELECTED_HOLE = 74;
	final static int ADD_NEW_HOLE = 75;
	Centrosomes centsJPanel=null;
	Stats statsJPanel = null;
	BlackHoles holesJPanel = null;
	String curMarkString="mark0";

	boolean redJButtonsMoveMark=false,greenJButtonsMoveMark=false,
		blueJButtonsMoveMark=false;
	
	int XMIN=0,XMAX=2048,YMIN=0,YMAX=2048; // the max raster size. THis is the only 
			// these bounds apper. Everything else refers back to them
	static int fullWidth=768, fullHeight=512; // the full size of the current stack opened by
			// the BioradFiles
	int curWidth=fullWidth,curHeight=fullHeight;
	
	int mouseMode = MOUSE_REPORTS_LOCATION_COLORS;
	int maxCache = 10;
	int singleChan=-1;
	ZseriesMainWindow parent=null;
	double redness=1.0, greenness=1.0, blueness=1.0;
	BioradFile redfile = null;
	BioradFile greenfile = null;
	BioradFile bluefile = null;
	boolean ifUseGrayScale=true;
	boolean ifDrawZNumbers=false;
	BioradCanvas  curStack = null;
	Image			offScrImage = null;
	boolean		dragging = false, offScrUpToDate = false;
	int				mouseStartX, mouseStartY; 		// Used when dragging centros around
	DataInputStream	centroFile;						// Global because its used in run()
	int				stackX = 0, stackY = 0, stackZ = 0;
	int				loadType = 0; 					// Specifies what's being loaded - not really used now
	boolean showAllMarkers=false;
	int curMarker = 0;
	int measureMark1=0, measureMark2=0;
	RGBMarker  [] marks = {new RGBMarker(this),  
			       new RGBMarker(this), new RGBMarker(this),
			       new RGBMarker(this), new RGBMarker(this),
			       new RGBMarker(this), new RGBMarker(this),
			       new RGBMarker(this), new RGBMarker(this),
			       new RGBMarker(this), new RGBMarker(this)}; 
	String redFilename="nameless",greenFilename="nameless",blueFilename="nameless";
	
	String lastOpenedRedName = "nameless"; 
	// lastOpened... names used for automatic opening of new triads of files...
 	String lastOpenedGreenName = "nameless";
 	String lastOpenedBlueName = "nameless";
 	RandomAccessFile triadNames;

	int mouseStatsNJFrames=0;
	int [] mouseStatsNclicks=null;
	int [] mouseStatsSumRedIntens=null;
	int [] mouseStatsSumGreenIntens=null;
	int [] mouseStatsSumBlueIntens=null;
	Thread writeMovieJFrames=null;
	int movieJFrameNum=-1, movieStopJFrame=-1, jpegQuality=-1; 
	double jpegZoomFac=1.;
	String baseMovieJFrameName=null;
	boolean ifUseSqrtTransformFor16BitData = false;
	long lastMilliTime=-7777;
	int maxDelay;
	public boolean alreadyPainted=false,repaintUrgentlyCalled = false,moviePlaying=false,ifTellTiming=false;
	
	private long milliTimeNow() {
		return (new Date()).getTime(); // returns milliseconds seconds
		}	
				
	public void movieStatus(boolean st) {
		moviePlaying=st;
		//talk("moviePlaying == "+moviePlaying);
		}
		
	public void makeUseSqrtTransformButton() {
		if(parent.iusqt == null)
			parent.iusqt = new IfUseSqrtTransform(this);
		parent.iusqt.setVisible(true);
		}
		
	public void useSqrtTransform(boolean ifTrue) {
		ifUseSqrtTransformFor16BitData = ifTrue;
		if(redfile != null) redfile.useSqrtTransform(ifTrue);
		if(greenfile != null) greenfile.useSqrtTransform(ifTrue);
		if(bluefile != null) bluefile.useSqrtTransform(ifTrue);
		}

 	public void showYourself() {
		parent.setVisible(true);
		setVisible(true);
		}
		
	public void webCacheLevel(int lev) {
		if(redfile != null) 
			redfile. webCacheLevel(lev);
		if(greenfile != null) 
			redfile. webCacheLevel(lev);
		if(bluefile != null) 
			redfile. webCacheLevel(lev);
		}
		
	public ShowPicJPanel(String redFilename, String greenFilename,
	      String blueFilename, ZseriesMainWindow mainWindow) {
	    this.parent = mainWindow;
	    recordTriadNames(redFilename,  greenFilename,  blueFilename) ;
		if(ifdiags) talk("open redfile = "+redFilename);
	    try { 
	    	talk("try to open redfile = "+redFilename);
	    	redfile = new BioradFile(this,redFilename,maxCache,0);
	    	talk("try to write its trailer.");
			redfile.writeTrailerToHTMLFile(0);
	    	talk("successfully wrote the trailer.");
			}
	    catch(Exception err) {
		    talk("Error opening "+redFilename+" got this exception "+err);	    	
		    redfile=null;
			this.redFilename="nameless";
		    }
		this.redFilename=redFilename;
		if(parent.aFileNameThatWorked == null && redfile!=null && redfile.isValid())
			parent.aFileNameThatWorked = ""+redFilename;			
		if(redfile != null && !redfile.isValid()) { 
		    redfile=null;
			this.redFilename="nameless";
			}		    
				   
	    try {
		if(ifdiags) talk("open greenfile = "+greenFilename);
		greenfile = new BioradFile(this,greenFilename,maxCache,1);
		greenfile.writeTrailerToHTMLFile(1);
		this.greenFilename=greenFilename;
		if(parent.aFileNameThatWorked == null && greenfile!=null && greenfile.isValid())
			parent.aFileNameThatWorked = ""+greenFilename;			
		if(greenfile != null && !greenfile.isValid())  {
		    greenfile=null;
			this.greenFilename="nameless";
			}		    
		  }
	    catch(Exception err) {
		    greenfile=null;
			this.greenFilename="nameless";
		    System.out.println("Error opening "+greenFilename+"; got the exception <"+err+">");
		    }
		   
	    try {
		if(ifdiags) talk("open bluefile = "+blueFilename);
		bluefile = new BioradFile(this,blueFilename,maxCache,2);
		bluefile.writeTrailerToHTMLFile(2);
		this.blueFilename=blueFilename;
		if(parent.aFileNameThatWorked == null && bluefile!=null && bluefile.isValid())
			parent.aFileNameThatWorked = ""+blueFilename;			
		if(bluefile != null && !bluefile.isValid())  {
		    bluefile=null;
			this.blueFilename="nameless";
			}		    
		}
	    catch(Exception err) {
		    bluefile=null;
		    System.out.println("Error opening "+blueFilename+"; got the exception <"+err+">");
			this.blueFilename="nameless";
		    }
		    
		 if(redfile != null || greenfile!= null || bluefile!=null) {
				if(ifdiags) talk("try to create bioradCanvas");
		    	makeNewMainStack(redfile,greenfile,bluefile);
		      	}
		 else {
			talk("No valid biorad files found. Bye");
			talk("redfile = "+redfile);
			talk("greenfile = "+greenfile);
			talk("bluefile = "+bluefile);
			//System.exit(0); 
			}

		requestFocus();
	    for(int i=1;i<11;i++)
		marks[i].adoptNewStack(curStack); 
	    // at birth they are unselected and invisible.
	    marks[0].select(true);
	   addKeyListener(this);
	   addMouseListener(this);
	   addMouseMotionListener(this);
		
		WidgetMaker wmk = new WidgetMaker(this); 
			
	    if(ifdiags) talk("itsJPanel successfully created");
	}

	public void makeNewMainStack(BioradFile redfile,BioradFile greenfile,BioradFile bluefile) {
		if(curStack != null) 
			curStack.sepuku();
		curStack = new BioradCanvas(redfile,greenfile,bluefile, this,sectionType, parent.navigatorJPanel);
		setStackWidthAndHeight();
		setImageSize(1);
		talk("curStack canvas successfully created");
		newColors();
		}
		
	public boolean assertRawDataTransformationMode(int mode) {
		return (parent.assertRawDataTransformationMode(mode));
		}

	public void setNewGainCurveFit(int ifRGB, double concentrationMappedTo255,
				double [] gainCurveFitCoeffs, boolean ifPurgeCache) {
		parent.setNewGainCurveFit(ifRGB,concentrationMappedTo255,gainCurveFitCoeffs,
				ifPurgeCache);
		}
		
    public void writeMouseClickIntensityStats() {
		String stg;
		for(int i=0;i < curStack.NJFrames;i++) {
			if(i < mouseStatsNJFrames && mouseStatsNclicks[i]>0) {
				writeAString((""+i+"    "+(int)(mouseStatsSumRedIntens[i]/mouseStatsNclicks[i])+
						"   "+(int)(mouseStatsSumGreenIntens[i]/mouseStatsNclicks[i])+"   "
							+(int)(mouseStatsSumBlueIntens[i]/mouseStatsNclicks[i])+"   "+mouseStatsNclicks[i]),
									parent.mouseCllickIntensityStats);
				talk("at z="+i+", avg RGB intens = "+(int)(mouseStatsSumRedIntens[i]/mouseStatsNclicks[i])+
						"   "+(int)(mouseStatsSumGreenIntens[i]/mouseStatsNclicks[i])+"   "
							+(int)(mouseStatsSumBlueIntens[i]/mouseStatsNclicks[i])+" from "+mouseStatsNclicks[i]+
					" measurements");
				}
			}
		mouseStatsNJFrames=0;
		mouseStatsNclicks=null;
		mouseStatsSumRedIntens=null;
		mouseStatsSumGreenIntens=null;
		mouseStatsSumBlueIntens=null;
		}
		
	private void writeAString(String stg,RandomAccessFile inout) {
		byte [] buf = new byte[stg.length()+1];
		stg.getBytes(0,stg.length(),buf,0);
		buf[stg.length()] = 10;
			try {
			inout.write(buf);
			}
		catch (IOException ioex) {
			talk("write to file failed: "+ioex);
			}
		}

	public void initMouseClickIntensityStats() {
		mouseStatsNJFrames=curStack.NJFrames;
		mouseStatsNclicks = new int[mouseStatsNJFrames];
		mouseStatsSumRedIntens = new int[mouseStatsNJFrames];
		mouseStatsSumGreenIntens = new int[mouseStatsNJFrames];
		mouseStatsSumBlueIntens = new int[mouseStatsNJFrames];
		for(int i=0;i < mouseStatsNJFrames;i++) {
			mouseStatsNclicks[i]=0;
			mouseStatsSumRedIntens[i]=0;
			mouseStatsSumGreenIntens[i]=0;
			mouseStatsSumBlueIntens[i]=0;
			}
		}
		
	public void setJPanelTitle(String stg) {
		if(parent != null) 
			parent.setTitle(stg);
		}
	

    public void writeTiff() {
	    curStack.writeTiffFile();
	    }
	   
    public void writeGmoRas() {
	    curStack.writeGmoRasFile();
	    }
	   
    public void writeJpeg() {
	    curStack.writeJpeg();
	    }
	   
	public void showHideMarks(boolean ifShowem) {
		showAllMarkers=ifShowem;
		if(showAllMarkers) {
			for(int i=1;i<11;i++)
				marks[i].appear();
			}
		else {
			for(int i=1;i<11;i++)
				marks[i].disappear();
			}
		forceNewDrawing();
		reDraw();
		}
		
    public double [] tellRGBness() {
	double [] rgbn = {1., 1., 1.};
	return rgbn;
	}	    

    public int [] getRedsColors() {
	if(parent != null)
	    return (parent.getRedsColors());
	else {
	    int [] truered = {255, 0, 0, 0};
	    return truered;
	    }
	}
    public int [] getRedsCustLUT() {
	if(parent != null)
	    return (parent.getRedsCustLUT());
	else {
	    return ramp();
	    }
	}

    public int [] getGreensColors() {
	if(parent != null)
	return (parent.getGreensColors());	
	else {
	    int [] truegreen = {0, 255, 0, 0};
	    return truegreen;
	    }
	}
    public int [] getGreensCustLUT() {
	if(parent != null)
	    return (parent.getGreensCustLUT());
	else {
	    return ramp();
	    }
	}

    public int [] getBluesColors() {
	if(parent != null)
	return (parent.getBluesColors());	
	else {
	    int [] truegreen = {0, 0, 255, 0};
	    return truegreen;
	    }
	}
	
    public int [] getBluesCustLUT() {
	if(parent != null)
	    return (parent.getBluesCustLUT());
	else {
	    return ramp();
	    }
	}
 
	private int [] ramp() {
	    int [] ddd = new int[256];
	    for(int i=0;i<256;i++) ddd[i]=i;
	    return ddd;
	    }
	
	public void blotOutHoles(BioradStackConfig BSC, byte [] ras, int ncols, int nrows, int nsect ) {
		parent.blotOutHoles(BSC, ras, ncols, nrows, nsect);
		}
	   
	public void invalidateRasterCaches(int ifRGB) {
   		switch (ifRGB) {
   			case (0) :
   				talk("invalidate Red RasterCache)");
   				if(redfile != null)
   					redfile.cachePurge();
   				break;
   				
   			case (1) :
   				talk("invalidate Green RasterCache)");
   				if(greenfile != null)
   					greenfile.cachePurge();
   				break;
   				
   			case (2) :
   				talk("invalidate Blue RasterCache)");
   				if(bluefile != null)
   					bluefile.cachePurge();
   				break;
   			default: break;	
   			} 			
   	}
   
 	public void  getNewStacks(SectionNavigator navigator, int sectionType, String workingFileName) { 
 		// call this to use already-open web servers of three stacks
 		talk("Try to open web stacks...");
		getNewStacks("webRed","webGreen","webBlue",navigator,sectionType,workingFileName);
		}

	private boolean rewind(RandomAccessFile theFile) {
		try{theFile.seek((long)0);}
		catch(IOException e) {
			talk("Caught IOException "+e+" when trying to rewind input file???");
			return false;
			}
		return true;
		}

	private void writeFileString(String stg) {
		if(stg==null) 
			stg="namelessFile";
		byte [] buf = new byte[stg.length()+1];
		stg.getBytes(0,stg.length(),buf,0);
		buf[stg.length()] = 10;
			try {
			triadNames.write(buf);
			}
		catch (IOException ioex) {
			talk("write to file failed: "+ioex);
			}
		}
		
	private void recordTriadNames(String rname, String gname, String bname) {
		if(ifMakingMask) return;
 		lastOpenedRedName = (rname==null? "" : rname);
 		lastOpenedGreenName = (gname==null? "" : gname);
 		lastOpenedBlueName = (bname==null? "" : bname);
 		if(rname != "") parent.exhibitFileName(rname);
 		else if(gname != "") parent.exhibitFileName(gname);
 		else parent.exhibitFileName(bname);
 		if(!parent.UseTriadFileNames) {
 			talk("recordTriadNames() got names: "+rname+", "+gname+", "+bname+" but UseTriadFileNames="+
 						parent.UseTriadFileNames);
 			return;
 			}
 		// record in the special disk file what the names are of the files you are about to open
 		try{triadNames = new RandomAccessFile(whereIsVefFire0+"staxTriadNames","rw");}
		catch(IOException e) {
			talk("cannot open "+whereIsVefFire0+"staxTriadNames. Got exception="+e);
			parent.UseTriadFileNames=false;
			}
		if(triadNames != null) {
			rewind(triadNames);
 			talk("recordTriadNames() recorded these names: "+rname+", "+gname+", "+bname);
			 writeFileString(lastOpenedRedName);
			 writeFileString(lastOpenedGreenName);
			 writeFileString(lastOpenedBlueName);
			 writeFileString("                                     ");
			 writeFileString("                                     ");
			 try{triadNames.close();}
			 catch(IOException e) {talk("oopsey");}
 			}
		}
		
 	public void getNewStacks(String redname,String greenname, String bluename,SectionNavigator navigator,
 					int sectionType,String workingFileName) {
 		ifdiags=true;
 		talk("getNewStacks() with sectionType="+sectionType);
		if(!ifMakingMask)
			recordTriadNames(redname,  greenname,  bluename) ;
				
 		if(redname.equals("webRed") || greenname.equals("webGreen") || bluename.equals("webBlue")) {
			ifWebStacks=true;
			parent.ifWebStacks=true;
			this.sectionType=sectionType;
 			talk("getNewStacks will take data from web stacks");
 			}
 		else {
			parent.ifWebStacks=false;
			parent.sectionType=0;
 			}
		try {
			// save the previous settings of the x and o markers and curJFrame
			// clear pointers from objects...
			parent.exhibitRedChanLUT.canvas.myMaster=null;
			parent.exhibitGreenChanLUT.canvas.myMaster=null;
			parent.exhibitBlueChanLUT.canvas.myMaster=null;
			
			// close and eliminate the previous BioradFile s
		    if(redfile != null) {
		    	redfile.sepuku();
				redfile=null;
		    	}
		    if(greenfile != null) {
		    	greenfile.sepuku();
			    greenfile=null;
		    	}
		    if(bluefile != null) {
		    	bluefile.sepuku();
			    bluefile=null;
		    	}

		    if(redname!=null) {
		     try {
			if(ifdiags) talk("open redfile = "+redname);
			if(ifWebStacks)  {
				redfile = new BioradFile(this,maxCache,0,workingFileName,navigator,sectionType);
				}
			else {
				redFilename=redname; // new real file name...
				if(redname != "" && redname != null)
					redfile = new BioradFile(this,redname,maxCache,0);
				else redfile = null;
				}
			if(redfile != null && !redfile.isValid()) 
			   redfile=null;
			}
		    catch(Exception err) {
			 redfile=null;
			    System.out.println("Error opening "+redname);
			    }
			}
		    else redfile=null;
		  	if(redfile != null)
		  		redfile.writeTrailerToHTMLFile(0);
	    
		if(greenname!=null) { 
			try {
			    if(ifdiags) talk("open greenfile = "+greenname);
				if(ifWebStacks) 
			    	greenfile = new BioradFile(this,maxCache,1,workingFileName,navigator,sectionType);
			    else {
					greenFilename=greenname;
					if(greenname != "" && greenname != null)
			    		greenfile = new BioradFile(this,greenname,maxCache,1);
			    	else greenfile=null;
			    	}
			    if(greenfile != null && !greenfile.isValid()) 
					greenfile=null;
			    }
			catch(Exception err) {
			    greenfile=null;
			    System.out.println("Error opening "+greenname);
			    }
			}
		    else greenfile=null;
		  	if(greenfile != null)
		  		greenfile.writeTrailerToHTMLFile(1);
		    
		    if(bluename!=null) {
			  try {
			    if(ifdiags) talk("open bluefile = "+bluename);
				if(ifWebStacks)
			    	bluefile = new BioradFile(this,maxCache,2,workingFileName,navigator,sectionType);
			    else {
			    	blueFilename=bluename;
					if(bluename != "" && bluename != null)
			    		bluefile = new BioradFile(this,bluename,maxCache,2);
			    	else
			    		bluefile=null;
			    	}
			    if(bluefile != null && !bluefile.isValid()) 
				bluefile=null;
			    }
			catch(Exception err) {
			    bluefile=null;
			    System.out.println("Error opening "+bluename);
			    }
			}
		    else bluefile=null;
		  	if(bluefile != null)
		  		bluefile.writeTrailerToHTMLFile(2);
		    
		    makeNewMainStack(redfile,greenfile,bluefile);
			curStack.curJFrame = (curStack.NJFrames)/2;
			curStack.howManySections();
			curStack.setImageSize();
		    for(int i=0;i<3;i++)
				marks[i].adoptNewStack(curStack);			
		    curStack.showAJFrame((curStack.NJFrames)/2);
			}
		catch(Exception e) {
		    System.out.println("Error opening biorad file.  Exiting");
		    //System.exit(1);
			} 
		redFilename= redfile==null? "nameless" : redname;
		greenFilename = greenfile==null? "nameless" : greenname;
		blueFilename = bluefile==null? "nameless" : bluename;
		parent.navigatorJPanel.labelSectionTypes(sectionType);
		requestFocus();
	}	
		   

	static void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}
		
	public void gotosection(int gotosect) {
		if(gotosect>= curStack.NJFrames)
			gotosect = curStack.NJFrames-1;
		if(gotosect<0) gotosect=0;
		curStack.showAJFrame(gotosect);
		}
    
// catch mouseMovement events...
	public void mouseMoved(java.awt.event.MouseEvent event){
		int x = event.getX();
		int y = event.getY();
		double [] mxyz = {(double)x, (double)y, (double)(curStack.curJFrame)};
		curStack.unScaleCoords(mxyz);
		int [] colors =  curStack.getColors((int )mxyz[0],(int )mxyz[1]);
		parent.navigatorJPanel.pixelReport((int)mxyz[0], (int)mxyz[1], curStack.curJFrame,
			colors[0],colors[1],colors[2]);
		}
			
	public void mouseDragged(java.awt.event.MouseEvent event){
		int x=event.getX(),y=event.getY();

		double [] mxyz = {(double)x, (double)y, 
				(double)(curStack.curJFrame)};
		curStack.unScaleCoords(mxyz);
		if((mouseMode==MOUSE_MOVES_OUTERBOX_CENTER || mouseMode==MOUSE_MOVES_TRANSECT_CENTER ||
				mouseMode==MOUSE_MOVES_INNERBOX_CENTER) && statsJPanel != null) {
			statsJPanel.moveBoxCenter(mxyz, mouseMode);
			mouseStartX=x;
			mouseStartX=y;
			}
		
		else if((mouseMode==MOUSE_DRAGS_POLYGON_VERTEX || mouseMode==MOUSE_DRAGS_TRANSECT_VERTEX)
					 && statsJPanel != null)   {
			statsJPanel.moveVertex(mxyz, mouseMode);
			mouseStartX=x;
			mouseStartX=y;
			}
		}
	
// catch all other mouse events 
	
	public void mouseReleased(java.awt.event.MouseEvent event) {
		bypassBooleanReturnFromOldMouseUp(event.getX(),event.getY());
		requestFocus();
		}
		
		
	public void mouseClicked(java.awt.event.MouseEvent event) {
		// talk("Mouse Clicked at ("+event.getX()+", "+event.getY()+")");
		}
		
	public void mouseEntered(java.awt.event.MouseEvent event) {
		// talk("Mouse entered at ("+event.getX()+", "+event.getY()+")");
		}
		
	public void mouseExited(java.awt.event.MouseEvent event) {
		// talk("Mouse exited at ("+event.getX()+", "+event.getY()+")");
		}

	private boolean bypassBooleanReturnFromOldMouseUp(int x, int y) {
		double [] mxyz = {(double)mouseStartX, (double)mouseStartY, 
				(double)(curStack.curJFrame)};
		curStack.unScaleCoords(mxyz);
		switch (mouseMode) {
			case PICK_NEAREST_CENT :
			case MOVE_SELECTED_CENT : // transmit pic location to centrosome panel
			case ADD_NEW_CENT:
				if(centsJPanel != null) {
					centsJPanel.processMouseClick(mxyz, mouseMode);
					centsJPanel.show();
					centsJPanel.requestFocus(); 
					}
				break;

			case PICK_NEAREST_HOLE :
			case MOVE_SELECTED_HOLE : // transmit pic location to centrosome panel
			case ADD_NEW_HOLE:
				if(holesJPanel != null) {
				talk("send mouse click to Black Holes JPanel w/ mouseMode="+mouseMode);
					holesJPanel.processMouseClick(mxyz, mouseMode);
					holesJPanel.show();
					holesJPanel.requestFocus(); 
					}
				break;

			case MOUSE_MOVES_OUTERBOX_CENTER:
			case MOUSE_MOVES_INNERBOX_CENTER:
			case MOUSE_DRAGS_POLYGON_VERTEX:
			case MOUSE_DRAGS_TRANSECT_VERTEX:
				if(statsJPanel != null) {
					statsJPanel.computeArea();
					statsJPanel.show();
					if(mouseMode==MOUSE_DRAGS_POLYGON_VERTEX) { // reprime to drag another vertex
						statsJPanel.primeMouseToDragPolygonVertex();
						requestFocus();
						}
					else 
						statsJPanel.requestFocus(); 
					}
				break;

		
			case MOUSE_CLICKS_DEFINE_POLYGON:
			case MOUSE_CLICKS_DEFINE_TRANSECT:
				if(statsJPanel != null && statsJPanel.nextVertexOfPolygon(mxyz, mouseMode))
					return true; // keeping mouseMode==MOUSE_CLICKS_DEFINE_POLYGON set
				if(statsJPanel != null) { // hand back focus to statsJPanel
					statsJPanel.show();
					statsJPanel.requestFocus(); 
					}
				break;

			case MOUSE_REPORTS_LOCATION_COLORS :
			default:
				int [] colors =  curStack.getColors(mouseStartX,mouseStartY);
				talk("x="+mouseStartX+"->"+(int)mxyz[0]+
						",  y="+mouseStartY+"->"+(int)mxyz[1]+
						", Z="+curStack.curJFrame+
						",  red="+colors[0]+", green="+colors[1]+", blue="+colors[2]);
				if(mouseStatsNJFrames>0 && curStack.curJFrame<mouseStatsNJFrames) { // record in stats file
					++mouseStatsNclicks[curStack.curJFrame];
					mouseStatsSumRedIntens[curStack.curJFrame] += colors[0];
					mouseStatsSumGreenIntens[curStack.curJFrame] += colors[1];
					mouseStatsSumBlueIntens[curStack.curJFrame] += colors[2];
					talk("RGB averages are now "+mouseStatsSumRedIntens[curStack.curJFrame]/mouseStatsNclicks[curStack.curJFrame]+"   "+
						mouseStatsSumGreenIntens[curStack.curJFrame]/mouseStatsNclicks[curStack.curJFrame]+"   "+
						mouseStatsSumBlueIntens[curStack.curJFrame]/mouseStatsNclicks[curStack.curJFrame]+
						" from "+mouseStatsNclicks[curStack.curJFrame]+" measurements");
					}
				break;
			
			case MOUSE_PICKS_A_MARK: // select mark closest to mouse location
				selectMarker(findNearestMarkerToMouse(mouseStartX,mouseStartY));
				break;
				
			case MOUSE_PICKS_MEASURE_MARK_1:
			case MOUSE_PICKS_MEASURE_MARK_2:
				if(measureMarks(mouseMode)) return true;
			    break;
			    
			
			case  MOUSE_MOVES_SELECTED_MARK:
				marks[curMarker].moveToMouseLoc(mouseStartX,mouseStartY);
				reDraw();
				break;

			case  MOUSE_MOVES_RED_SELECTED_LEAF:
			  if(singleChan<0 || singleChan==0) {
			    marks[curMarker].moveLeafToMouseLoc(0, mouseStartX, mouseStartY);
			    talk("move selected red leaf of "+curMarkString+
				    " to mouse click location");
			    reDraw();
			    }
			  else talkWhichMarkMoves();
			    break;

			case  MOUSE_MOVES_GREEN_SELECTED_LEAF:
			  if(singleChan<0 || singleChan==1) {
			    marks[curMarker].moveLeafToMouseLoc(1, mouseStartX, mouseStartY);
			    talk("move selected green leaf of "+curMarkString+
				    " to mouse click location");
			    reDraw();
			    }
			  else talkWhichMarkMoves();
			    break;

			case  MOUSE_MOVES_BLUE_SELECTED_LEAF:
			  if(singleChan<0 || singleChan==2) {
			    marks[curMarker].moveLeafToMouseLoc(2, mouseStartX, mouseStartY);
			    talk("move selected blue leaf of "+curMarkString+
				    " to mouse click location");
			    reDraw();
			    }
			  else talkWhichMarkMoves();
			    break;
			}
		if(mouseMode != MOUSE_DRAGS_POLYGON_VERTEX) // leave MOUSE_DRAGS_POLYGON_VERTEX mode active
			mouseMode = MOUSE_REPORTS_LOCATION_COLORS;
		return false;
			}
		
	public void mousePressed(java.awt.event.MouseEvent event) {
		    mouseStartX = event.getX();
		    mouseStartY = event.getY();
		}
		
	public void primeMouseForTask(int mouseClickMeans, Stats statsJPanel) {
		mouseMode = mouseClickMeans;
		this.statsJPanel = statsJPanel;
		}
		
	public void primeMouseForTask(int mouseClickMeans, BlackHoles holesJPanel) {
		mouseMode = mouseClickMeans;
		this.holesJPanel = holesJPanel;
		}
	
		
	public void primeMouseForTask(int mouseClickMeans, Centrosomes centsJPanel) {
		mouseMode = mouseClickMeans;
		this.centsJPanel = centsJPanel;
		}
		
	public void primeMouseForTask(int mouseClickMeans) {
		mouseMode = mouseClickMeans;
		}
		
	public void setMoveSectionsOrMarkFlags(boolean redJButtonsMoveMark,
			boolean greenJButtonsMoveMarkint ,boolean blueJButtonsMoveMark) {
		this.redJButtonsMoveMark = redJButtonsMoveMark;
		this.greenJButtonsMoveMark = greenJButtonsMoveMark;
		this.blueJButtonsMoveMark = blueJButtonsMoveMark;
		}
	
	public boolean measureMarks(int mode) {	
		if(mode ==-1) { // external call; set up to measure marks...
			mouseMode = MOUSE_PICKS_MEASURE_MARK_1;
			talk("measuring distance between marks. Click mouse");
			talk("to select first mark");
			return true;
			}
		if(mode == MOUSE_PICKS_MEASURE_MARK_1){
			measureMark1 =  findNearestMarkerToMouse(mouseStartX, mouseStartY);
			selectMarker(measureMark1);
			talk("Now click mouse on second mark to which you want to measure");
			mouseMode=MOUSE_PICKS_MEASURE_MARK_2;
			return true;
			}
		if(mode == MOUSE_PICKS_MEASURE_MARK_2) {
			measureMark2 =  findNearestMarkerToMouse(mouseStartX, mouseStartY);
			selectMarker(measureMark2);
			double [] mark1Loc = marks[measureMark1].tellAbsLoc();
			talk("First mark is "+marks[measureMark1].myStatsString());
			talk("Second mark is "+marks[measureMark2].myStatsString());
			    
			talk("The distance between marks "+measureMark1+" and "+
			measureMark2+" is "+ marks[measureMark2].absDistanceFrom(mark1Loc));
			return false;
			}
		return false;
		}


    private void talkWhichMarkMoves() {
	switch (singleChan) {
	    case (0) :
		talk("while displaying the red chanel only");
		talk("you can move only the mark's red leaf");
		break;
	    case (1) :
		talk("while displaying the green chanel only");
		talk("you can move only the mark's green leaf");
		break;
	    case (2) :
		talk("while displaying the blue chanel only");
		talk("you can move only the mark's blue leaf");
		break;
	    }
	}

	private int findNearestMarkerToMouse(int mx,  int my) {
	    double dist = marks[1].distanceToMouse(mouseStartX,mouseStartY);
	    int isel = 1;
	    double ddst;
	    for(int i=2;i<11;i++) 
		if((ddst = marks[i].distanceToMouse(mouseStartX,mouseStartY)) <dist) {
		    isel=i;
		    dist=ddst;
		    }
	    return(isel);	    
	    }
	    
	public void reallyReDraw() {
		forceNewDrawing();
		reDraw();
		}
		
	public void reDraw() {
		curStack.showJumpJFrame(0);
		}
	    
	private void setStackWidthAndHeight() {
		boolean ifResizeParent=false;
		if(fullWidth != curStack.nwide || fullHeight != curStack.nhigh) 
			ifResizeParent=true;
		fullWidth = curStack.nwide;
		fullHeight = curStack.nhigh;
		//talk("ShowPicJPanel setStackWidthAndHeight sets fullWidth="+fullWidth+" and fullHeight="+fullHeight);
		if(ifResizeParent) {
			parent.resize();
			//reDraw();
			}
		}

	public void setImageSize(int imsz) {
		curStack.setImageSize();		
		curWidth = fullWidth;
		curHeight = fullHeight;
		offScrImage = createImage(curWidth,curHeight);
		talk("setImageSize.setImageSize()");
		forceNewDrawing();
		picInvalid();
		reDraw();
		}
	
	public void keyTyped(java.awt.event.KeyEvent event) {
		}
		
	public void keyPressed(java.awt.event.KeyEvent event) {
		if (curStack == null) return;
		int	i, num;
		char key = event.getKeyChar();
		switch(key) {

			case 'n':
			case 'N':
				tellFileNames();
				break;
				
			case '-':
				curStack.showPreviousJFrame();
				break;
			case '+': case '=':
				curStack.showNextJFrame();
				break;
			
			case '>' :
			case '.' :
				curStack.showJumpJFrame(parent.navigatorJPanel.bigJump());
				break;
			case '<' :
			case ',' :
				curStack.showJumpJFrame(-parent.navigatorJPanel.bigJump());
				break;
			
			case 'J' :
				parent.navigatorJPanel.adjustBigJump(1);
				break;	
		
			case 'j' :
				parent.navigatorJPanel.adjustBigJump(-1);
				break;	
		
			case 'd' :
			case 'D' :
				forceNewDrawing();
				reDraw();
				break;
				
			case 'a':
			case 'A': // show first frame
				curStack.showFirstJFrame();
				break;
				
			case 'm' :
			case 'M' :
				curStack.showMiddleJFrame();
				break;

			case 'z':
			case 'Z': // show last frame
				curStack.showLastJFrame();
				break;
				
			case '1' :  selectMarker(1); break;
			case '!' : visibilityToggleMarker(1); break;

			case '2' :  selectMarker(2); break;
			case '@' : visibilityToggleMarker(2); break;

			case '3' :  selectMarker(3);  break;
			case '#' :  visibilityToggleMarker(3); break;

			case '4' :  selectMarker(4);  break;
			case '$' :  visibilityToggleMarker(4); break;

			case '5' :  selectMarker(5);  break;
			case '%' :  visibilityToggleMarker(5); break;

			case '6' :  selectMarker(6);  break;
			case '^' :  visibilityToggleMarker(6); break;

			case '7' :  selectMarker(7);  break;
			case '&' :  visibilityToggleMarker(7); break;

			case '8' :  selectMarker(8);  break;
			case '*' :  visibilityToggleMarker(8); break;

			case '9' :  selectMarker(9);  break;
			case '(' :  visibilityToggleMarker(9); break;

			case '0' : selectMarker(10); break;
			case ')' :  visibilityToggleMarker(10); break;
			
			case 'H': 
				marks[curMarker].grow(10);
			    reDraw();
				break;
			case 'L' : // selected marker gets larger..
				marks[curMarker].grow();
			    reDraw();
				break;
			
			case 'W' : // selected mark gets wider
				marks[curMarker].boostWidth();
			    reDraw();
				break;
			    
			case 'w' : // selected mark gets less wide
				marks[curMarker].cutWidth();
			    reDraw();
				break;
				
			case 'T' : // selected mark gets less wide
				marks[curMarker].boostHeight();
			    reDraw();
				break;
				
			case 't' : // selected mark gets less wide
				marks[curMarker].cutHeight();
			    reDraw();
				break;
				
			case 'l' : // selected marker shrinks..
				marks[curMarker].shrink();
			    reDraw();
				break;
			case 'h': 
				marks[curMarker].shrink(10);
			    reDraw();
				break;
			case 'q': case 'Q':
				talk("Next mouse click moves "+curMarkString+" to mouse location");
				mouseMode = MOUSE_MOVES_SELECTED_MARK;
				break;
			case '|' : // collapse leafs ...
			    talk("Collapsing together all leafs of  "+curMarkString);
			    marks[curMarker].coincide();
			    reDraw();
			    break;
			case 'p' :
				measureMarks(-1);
			    break;	
			   
			case 'c' :
				if(maxCache>1) --maxCache;
				maxCache = curStack.adjustCacheSize(maxCache);
				break;
					
				
			case 'C' :
				maxCache = curStack.adjustCacheSize(maxCache+1);
				break;

			case '?': case '/':
				instructions();
				break;
			default:
				talk("Type ? h or H for help");
				return;
					}
		}
	
	public void keyReleased(java.awt.event.KeyEvent event) {
		}
	
	public void tellFileNames() {
		if(redfile != null && redfile.isValid() ) 
			  redfile.tellName(" red ");
		if(greenfile != null && greenfile.isValid() ) 
			greenfile.tellName("green");
		if(bluefile != null && bluefile.isValid() ) 
			 bluefile.tellName(" blue");
		talk(" ");
		}
		
	public void instructions() { 
	talk(" ");
    talk("Keys pressed in main window mean...    | a or A -> show stack's first section");
    talk(" -     -> move back one section        | m or M -> show middle section of stack");
    talk("+ or = -> move forward one section     | z or Z -> show stack's last section ");
    talk("> or . -> jump ahead  bigjump sections | < or ,  -> jump backward bigjump sections");
    talk("j or J -> cut or boost bigjump         | 0 1 2...-> select mark 0 1 2 etc.       ");
    talk("d or D -> reDraw current frame         | ) ! @ ..-> hide/show toggle for marks 0 1 2 etc");
    talk("L or l -> selected mark Larger/smaller | T or t  -> make selected mark Taller or less tall");
    talk("H or h -> Huge step versions of L or l | W or w  -> make selected mark Wider or less wide");
    talk("q or Q -> next mouse click moves mark  | C or c  -> increase or decrease raster cache size");
    talk("n or N -> report file names            | | collapses all leafs of current mark to coincide");
    talk("? or / -> print these instructions     | p       -> tell distance between marks");
	talk(" ");
    }

   public void dockMarker(int iwh) { //return this marker to the dock
    	if(iwh<=0 || iwh>10) {
    		talk("illegal call to dockMarker("+iwh+")");
    		return;
    		}
    	marks[iwh].returnToDock();
    	talk("mark # "+iwh+" returns to dock location at (0,0,0)");
    	reDraw();		
    	}

    public void alignMarker(int iwh) { // select a arker and then redraw.
    	if(iwh<=0 || iwh>10) {
    		talk("illegal call to alignMarker("+iwh+")");
    		return;
    		}
    	double [] redOffsets = marks[iwh].tellLeafOffset(0);
    	double [] greenOffsets = marks[iwh].tellLeafOffset(1);
    	double [] blueOffsets = marks[iwh].tellLeafOffset(2);
	if(marks[iwh].leaf[0].isActive()) {
    	    curStack.Xshifts[0] = (int)(redOffsets[0] +.4999);
    	    curStack.Yshifts[0] = (int)(redOffsets[1] +.4999);
    	    curStack.Zshifts[0] = (int)(redOffsets[2] +.4999);
	    }

	if(marks[iwh].leaf[1].isActive()) {
    	    curStack.Xshifts[1] = (int)(greenOffsets[0] +.4999);
    	    curStack.Yshifts[1] = (int)(greenOffsets[1] +.4999);
    	    curStack.Zshifts[1] = (int)(greenOffsets[2] +.4999);
	    }

	if(marks[iwh].leaf[2].isActive()) {
    	    curStack.Xshifts[2] = (int)(blueOffsets[0] +.4999);
    	    curStack.Yshifts[2] = (int)(blueOffsets[1] +.4999);
    	    curStack.Zshifts[2] = (int)(blueOffsets[2] +.4999);
	    }
		tellShifts();
   		talk("aligning marker "+iwh);
		goToMarker(iwh);
		}

    public void unalign() { //reset all color plane shifts to zero
     	curStack.Xshifts[0] = 0;
    	curStack.Xshifts[1] = 0;
    	curStack.Xshifts[2] = 0;

    	curStack.Yshifts[0] = 0;
    	curStack.Yshifts[1] = 0;
    	curStack.Yshifts[2] = 0;

    	curStack.Zshifts[0] = 0;
    	curStack.Zshifts[1] = 0;
    	curStack.Zshifts[2] = 0;
		tellShifts();
		forceNewDrawing();
		reDraw();
		}
   
   public void allMarkersAdoptTheseLeafShapes(int redshape, 
	    int greenshape, int blueshape) {
	for(int i=1;i<11;i++)
	    marks[i].adoptTheseLeafShapes(redshape,greenshape,blueshape);
	}
		
   public void alignAllMarkers() { // select a arker and then redraw.
    	double [] redOffsets;
    	double [] greenOffsets;
    	double [] blueOffsets;
    	double [] xavg = {0,0,0};
    	double [] yavg = {0,0,0};
    	double [] zavg = {0,0,0};
    	int i, redActives=0, greenActives=0, blueActives=0;
    	for(i=1;i<11;i++)  {
    		if(marks[i].isActive()) { // mark is not in dock
    			redOffsets = marks[i].tellLeafOffset(0);
    			greenOffsets = marks[i].tellLeafOffset(1);
    			blueOffsets = marks[i].tellLeafOffset(2);
			if(marks[i].leaf[0].isActive()) {
			    ++redActives;
    			    xavg[0] += redOffsets[0];
    			    yavg[0] += redOffsets[1];
    			    zavg[0] += redOffsets[2];
			    }
			if(marks[i].leaf[1].isActive()) {
			    ++greenActives;
    			    xavg[1] += greenOffsets[0];
    			    yavg[1] += greenOffsets[1];
    			    zavg[1] += greenOffsets[2];
			    }
			if(marks[i].leaf[2].isActive()) {
			    ++blueActives;
    			    xavg[2] += blueOffsets[0];
    			    yavg[2] += blueOffsets[1];
    			    zavg[2] += blueOffsets[2];
			    }
    			}
    		}
    	if(redActives>0) { // OK there is at least one active red leaf
    		xavg[0] = xavg[0]/((double)redActives);
     		yavg[0] = yavg[0]/((double)redActives);
     		zavg[0] = zavg[0]/((double)redActives);
     		curStack.Xshifts[0] = (int)(xavg[0] +.4999);
    		curStack.Yshifts[0] = (int)(yavg[0] +.4999);
    		curStack.Zshifts[0] = (int)(zavg[0] +.4999);
		}
		
    	if(greenActives>0) { // OK there is at least one active green leaf
    		xavg[1] = xavg[1]/((double)greenActives);
     		yavg[1] = yavg[1]/((double)greenActives);
     		zavg[1] = zavg[1]/((double)greenActives);
    		curStack.Xshifts[1] = (int)(xavg[1] +.4999);
    		curStack.Yshifts[1] = (int)(yavg[1] +.4999);
    		curStack.Zshifts[1] = (int)(zavg[1] +.4999);
		}

    	if(blueActives>0) { // OK there is at least one active blue leaf
    		xavg[2] = xavg[2]/((double)blueActives);
     		yavg[2] = yavg[2]/((double)blueActives);
     		zavg[2] = zavg[2]/((double)blueActives);
     		curStack.Xshifts[2] = (int)(xavg[2] +.4999);
    		curStack.Yshifts[2] = (int)(yavg[2] +.4999);
    		curStack.Zshifts[2] = (int)(zavg[2] +.4999);
		}
	tellShifts();
	forceNewDrawing();
	reDraw();
    }
 
    public void goToMarker(int iwh) { // select a marker, go to it,  and then redraw.
    	if(iwh>0 && iwh<11) {
    		talk("go to marker # "+iwh);
			int zwh = (int)((marks[iwh].tellAbsLoc())[2] + .4999);
			if(zwh<0) zwh=0;
			if(zwh>=curStack.NJFrames) zwh = curStack.NJFrames - 1;
			curStack.curJFrame=zwh;
			selectMarker(iwh); // show the frame that contains the mark
			}
		else talk("illegal call to goToMarker("+iwh+")");
    	}
    	
    public void selectMarker(int iwh) { // select a marker and then redraw.
	curMarker=iwh;
	curMarkString="mark"+iwh;
	parent.shapeJPanel.adoptNewMarker(iwh, marks[curMarker]);
	parent.goJPanel.adoptNewMarker(iwh, marks[curMarker]);
	parent.moveJPanel.adoptNewMarker(iwh, marks[curMarker]);
	talk("Marker "+curMarker+" is currently selected:  "+marks[iwh].myStatsString());
	visibilityToggleMarker(-iwh);
	for(int i=1;i<11;i++) // unselect all markers
		marks[i].select(false);
	marks[iwh].select(true); // select this one
	// reset the gray marker moving buttons' labels...
	
	reDraw();
	}
					
    public boolean visibilityToggleMarker(int iwh) {
	if(iwh<0) {
	    iwh = -iwh;
	    marks[iwh].appear();
	    }
	else
	    marks[iwh].toggleVisibilty();
	reDraw();
	return(true);
	}
					
	private void tellShifts() {
	// we print these out backwards so right movement corresponds to positive shift 
	// numbers... 
		talk("red  channel  shifts are: xshift="+curStack.Xshifts[0]+", yshift="+
			(-curStack.Yshifts[0])+", zshift="+(-curStack.Zshifts[0]));
		talk("green channel shifts are: xshift="+curStack.Xshifts[1]+", yshift="+
			(-curStack.Yshifts[1])+", zshift="+(-curStack.Zshifts[1]));
		talk("blue  channel shifts are: xshift="+curStack.Xshifts[2]+", yshift="+
			(-curStack.Yshifts[2])+", zshift="+(-curStack.Zshifts[2]));
		talk(" ");
		}

	public void allShift(int xs, int ys, int zs) {
		for(int i=0; i<3; i++) {
			curStack.Xshifts[i] -= xs;
			curStack.Yshifts[i] -= ys;
			curStack.Zshifts[i] -= zs;
			}
		tellShifts();
		reallyReDraw();
		}		
		
	public void noShift(int chan) {
		// do global shifts so channel chan hos zero shifts
		curStack.Xshifts[chan] = 0;
		curStack.Yshifts[chan] = 0;
		curStack.Zshifts[chan] = 0;
		tellShifts();
		reallyReDraw();
		}
		
	public void noShifts() {
		// do global shifts so channel chan hos zero shifts
		for(int chan = 0;chan<3;chan++) {
			curStack.Xshifts[chan] = 0;
			curStack.Yshifts[chan] = 0;
			curStack.Zshifts[chan] = 0;
			}
		tellShifts();
		reallyReDraw();
		}
		
	public void MergedPicShifts() {
		curStack.Xshifts[0] = 0;
		curStack.Yshifts[0] = 0;
		curStack.Zshifts[0] = 1; // the red chan shifts
		
		curStack.Xshifts[1] = 0;
		curStack.Yshifts[1] = 0;
		curStack.Zshifts[1] = 0; // the green chan shifts
		
		curStack.Xshifts[2] = 0;
		curStack.Yshifts[2] = 0;
		curStack. Zshifts[2] = -1; // the blue chan shifts
		// If it's only two merged images, turn blue channel off...
		talk("curStack.NJFrames = "+curStack.NJFrames);
		if(curStack.NJFrames < 3) {
			curStack.ifblue=false;
			curStack.bluefile=null;
			curStack.myBlueFileName="";
			talk("There are only two channels in the merged image, red and green");
			}
		if(curStack.NJFrames < 2) {
			curStack.ifgreen=false;
			curStack.greenfile=null;
			curStack.myGreenFileName="";
			talk("There is only one channels in the merged image, red.");
			}
		tellShifts();
		curStack.showAJFrame(1);
		reallyReDraw();
		}
	
	public void redShift(int xs, int ys, int zs) {
	    if(redJButtonsMoveMark) {
		if(singleChan<0 || singleChan==0) 
		  marks[curMarker].chanOffsetMove(0, (double)xs, (double)ys,  (double)zs);
		else talk("You can move only the red marker leaf when in single color mode");
		}

	    else {
		curStack.Xshifts[0] -= xs;
		curStack.Yshifts[0] -= ys;
		curStack.Zshifts[0] -= zs;
		tellShifts();
		}
		forceNewDrawing();
		reDraw();
	    }
		
	public void greenShift(int xs, int ys, int zs) {
	    if(greenJButtonsMoveMark) {
		if(singleChan<0 || singleChan==1) 
		  marks[curMarker].chanOffsetMove(1, (double)xs, (double)ys,  (double)zs);
		  else talk("You can move only the green marker leaf when in single color mode");
		  }
	    else {
		curStack.Xshifts[1] -= xs;
		curStack.Yshifts[1] -= ys;
		curStack.Zshifts[1] -= zs;
		tellShifts();
		}
		forceNewDrawing();
		reDraw();
	    }
		
	public void blueShift(int xs, int ys, int zs) {
	    if(blueJButtonsMoveMark) { 
		 if(singleChan<0 || singleChan==2) 
		    marks[curMarker].chanOffsetMove(2, (double)xs, (double)ys,  (double)zs);
		 else talk("You can move only the blue marker leaf when in single color mode");
		 }
	    else {
		curStack.Xshifts[2] -= xs;
		curStack.Yshifts[2] -= ys;
		curStack.Zshifts[2] -= zs;
		tellShifts();
		}
		forceNewDrawing();
		reDraw();
	    }
		
	public void blueOnly() {
		if(blueness<0) blueness = - blueness;
		if(greenness>0) greenness = - greenness;
		if(redness>0) redness = -redness;
		forceNewDrawing();
		newColors();
		reDraw();
		}
		
	public void blueOff() {
		if(blueness>0) blueness = -blueness;
		newColors();
		forceNewDrawing();
		reDraw();
		}
		
	public void allColors() {
		if(blueness<0) blueness = - blueness;
		if(greenness<0) greenness = - greenness;
		if(redness<0) redness = -redness;
		newColors();
		forceNewDrawing();
		reDraw();
		}
		
	public void repaintExhibitRGBChanLUTS()	{
		parent.repaintExhibitRGBChanLUTS();
		}
			
	public void greenOnly() {
		if(blueness>0) blueness = - blueness;
		if(greenness<0) greenness = - greenness;
		if(redness>0) redness = -redness;
		newColors();
		forceNewDrawing();
		reDraw();
		}
	public void greenOff() {
		if(greenness>0) greenness = -greenness;
		forceNewDrawing();
		newColors();
		reDraw();
		}

	public void redOff() {
		if(redness>0) redness = -redness;
		forceNewDrawing();
		newColors();
		reDraw();
		}
	public void redOnly() {
		if(blueness>0) blueness = - blueness;
		if(greenness>0) greenness = - greenness;
		if(redness<0) redness = -redness;
		newColors();
		forceNewDrawing();
		reDraw();
		}
		
	public void grayToggle() {
		if((ifUseGrayScale = !ifUseGrayScale))
			talk("Using gray scale to show single channel pics");
		else talk("single channel pics shown in red or blue or green");
		newColors();
		forceNewDrawing();
		reDraw();
		}

	public double [] getBoosts(int sectionNum) {
		return (parent.getBoosts(sectionNum));
		}
		
	public void newColors() {
		singleChan=-1;
		if(redness>0 && greenness<0 && blueness<0) singleChan=0;
		if(redness<0 && greenness>0 && blueness<0) singleChan=1;
		if(redness<0 && greenness<0 && blueness>0) singleChan=2;
		curStack.setBrightness(redness,greenness,blueness,ifUseGrayScale,singleChan);
		// when singleChan>=0, don't allow movement of marker leafs in any chanel but the 
		// one shown.
		}
		
	public void dialogDone(MyDialog dlog, int dlog_id, boolean good) {
		if(!good) return;
		
		switch(dlog_id) {
			case GOTO_SLICE_DLOG:
				curStack.showAJFrame(((GotoDialog)dlog).getJFrame());
				repaint();
			break;
		}
	}

  	public void forceNewDrawing() {
  		// talk("ShowPicJPanel.forceNewDrawing()");
  		curStack.forceNewDrawing();
  		picInvalid();
   		}
 		
	public void picValid() {
		offScrUpToDate = true;
		}
		
	public void picInvalid() {
		offScrUpToDate = false;
		}
	
	public void repaintUrgently(int maxDelay) {
		lastMilliTime = milliTimeNow();
		alreadyPainted=false;
		repaintUrgentlyCalled=true;
		// talk("ShowPicJPanel.repaintUrgently("+maxDelay+") called at "+lastMilliTime);
		if(maxDelay<12) {
			this.maxDelay = -77;
			paintImmediately(parent.xDrawOrg,parent.yDrawOrg,parent.winwidth,parent.winheight);
			}
		// this is to force repainting within maxDelay milliseconds. 
		else {
			this.maxDelay = maxDelay;
			repaint((long)maxDelay);
			}
		}
				
	public void update2D(Graphics2D g) {
		talk("ShowPicJPanel.update2D() called");
		paint(g);
		}

	public void paint(Graphics g) {
		// talk("This should never happen. ShowPicJPanel.paint() called");
		paint2D((Graphics2D)g);
		}
		
	public void update(Graphics g) {
		// talk("ShowPicJPanel.update() called. Should never happen");
		paint((Graphics2D)g);
		}

	public void paint2D(Graphics2D g) {
		if(moviePlaying && alreadyPainted && ifTellTiming) {
			talk("                 ShowPicJPanel.paint() called at"+milliTimeNow()+" but screen was already painted" );
			return;
			}
	
		int	 i;
		long paintingStartTime = milliTimeNow();
		
		if(ifTellTiming && repaintUrgentlyCalled) 
			talk("ShowPicJPanel.paint2D() called "+(milliTimeNow()-lastMilliTime)+" ms after repaintUrgently("+maxDelay+")" );
		
		if(offScrImage == null) {
			if(curStack == null) return;
			offScrImage = createImage(curWidth,curHeight);
			offScrUpToDate = false;
			}
		if(!offScrUpToDate) {
			Graphics2D og = (Graphics2D)offScrImage.getGraphics();
			curStack.paint2D(og); // this makes micrograph up to date, and computes the 
				// (xDrawOrg,yDrawOrg) location from the current window size and scroll settings.
			if(ifTellTiming && repaintUrgentlyCalled) 
				talk("    ShowPicJPanel.paint2D() at "+(milliTimeNow()-paintingStartTime)+" ms when bioradCanvas has filled offscreen buffer" );
			}
			
		g.drawImage(offScrImage, 0, 0, this);
		int xorg = parent.xDrawOrg;
		int yorg = parent.yDrawOrg;
		if(!repaintUrgentlyCalled) {
			// draw the centrosomes, markers, histogram region, etc on top of the micrograph...
			if(centsJPanel != null) {
		    	centsJPanel.drawCents(g,xorg,yorg);
		    	}
		    
			if(holesJPanel != null) {
		    	holesJPanel.drawHoles(g,xorg,yorg);
		    	}
		    
			if(statsJPanel != null) {
		    	statsJPanel.draw(g,xorg,yorg);
		    	}		    
			int showMode = showAllMarkers? 2 :0;
			for(i=1;i<11;i++)
	    		marks[i].draw(g, showMode, curStack.curJFrame,xorg,yorg);
 			} 		
			
		parent.updateStackSliderPosition();
		setVisible(true);	
		alreadyPainted=true;	
		// requestFocus();
		if(ifTellTiming && repaintUrgentlyCalled) {
			talk("         ShowPicJPanel.paint2D() takes a total of "+(milliTimeNow()-paintingStartTime)+" ms to create image and paint it to the screen" );
			repaintUrgentlyCalled = false;
			}
		}
	
	public void changeInterlace() {
/*	    if(curStack.file.getInterlace() == -1) 
			curStack.file.setInterlace(0);
	    else if(curStack.file.getInterlace() == 0)
			curStack.file.setInterlace(1);
	    else curStack.file.setInterlace(0); */
	talk("OOPS. changeInterlace() does not work yet... ");
	}
	
	 public void start() {
		if(writeMovieJFrames==null) {
			//talk("sectionConsumerClient.start() makes new thread");
			writeMovieJFrames = new Thread(this);
			}
		writeMovieJFrames.start();
		}
		
	public void stop() {
		if(writeMovieJFrames!=null) 
			writeMovieJFrames.stop();
		}

	public void stopEverything() {
		movieJFrameNum = -1;
		movieStopJFrame = -1;
		baseMovieJFrameName=null;
		stop();
		writeMovieJFrames=null;
		talk("Use this method to stop everything you can think of");
		}

	public void run() { // this thread writes movie frames to disk
		GMORasFuncs rasWriter=null;
		WebFileClient  webFile=null;
		Tools info = new Tools();
		String filename;
		if(ifWriteWebfiles) {
			String hostname=info.getString("supply the hostname on which the web file server runs", Color.yellow);
			baseMovieJFrameName = info.getString("what is the base file name",Color.green);
			try{webFile = new WebFileClient(hostname);}
			catch(Exception e) {webFile=null; talk("failure in creating WebFileClient()");}
			}
		else {
			rasWriter = new GMORasFuncs();
			baseMovieJFrameName = rasWriter.getBaseFileName(new JFrame(),
				"pick the base file name for all movie jpeg frames");
			if(baseMovieJFrameName == null) {
				stop();
				writeMovieJFrames=null;
				return;
				}
			jpegQuality=-1;
			SetMovieFrameParms smpr = new SetMovieFrameParms(this,curStack.NJFrames);
			while(jpegQuality<0) {// SetMovieFrameParms() will set jpegQuality >= 0
				try{Thread.sleep(2000);} // sleep 6 seconds while waiting for user to
				catch(InterruptedException e) {;} // fill out the boxes
				smpr.flash();
				}
			smpr = null;
			talk("JpegQuality = "+ jpegQuality+", and zoom factor = "+jpegZoomFac);
			}
		talk("base movie frame file name is <"+baseMovieJFrameName+">");
		talk("firstFrame = "+movieJFrameNum+", and lastFrame = "+ movieStopJFrame);
		webCacheLevel(1);

		while(movieJFrameNum>=0 && movieJFrameNum <= movieStopJFrame && baseMovieJFrameName != null) {
			//talk("show section "+movieJFrameNum);
			curStack.showAJFrame(movieJFrameNum); // get the next frame displayed
			//talk("sleep 400");
			try{ Thread.sleep(600);} // sleep while it's obtained and displayed.
			catch(InterruptedException e) {talk("oopsy");}
			filename = appendSeqNumToName(baseMovieJFrameName,movieJFrameNum);
			if(ifWriteWebfiles) {
				webFile.sendFileToServer(filename, curStack.edgeTrim(curStack.curIm), 
						(curStack.curRows)*(curStack.curCols));
				}
				
			else {
    		rasWriter.writeJpeg((filename+".jpg"),curStack.curRows,curStack.curCols,
    			  	curStack.edgeTrim(curStack.curIm),jpegQuality,jpegZoomFac);}
			++movieJFrameNum;  
			try{ Thread.sleep(40);} 
			catch(InterruptedException e) {talk("oopsy");} 
			}
		webCacheLevel(2);
		movieJFrameNum = -1;
		writeMovieJFrames=null;
		baseMovieJFrameName=null;
		talk("");
		talk("");
		talk("Finished writing movie frames to disk... ");		
		talk("");
		stop();
		return;
		} 
		
	private String appendSeqNumToName(String baseName, int fourDigitSeqNum) {
		String dgt="";
		if(fourDigitSeqNum<10) dgt = "000"+fourDigitSeqNum;
		else if (fourDigitSeqNum<100) dgt = "00"+fourDigitSeqNum;
		else if (fourDigitSeqNum<1000) dgt = "0"+fourDigitSeqNum;
		else dgt = ""+fourDigitSeqNum;
		return (baseName+dgt);
		}

}
