package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.lang.*;
import java.util.*;
import java.awt.*;  import javax.swing.*;

class ThreshFltr {
	SegmenterNode nd=null;

	public ThreshFltr(SegmenterNode nd) {
		this.nd=nd;
		}

	public void tellWhatYouDo() {
		nd.talk("");
		nd.talk("The ChopOr filter has two parameters, Athresh and Bthresh.");
		nd.talk("It has two input rasters, pic1 and pic2. At each pixel, its output");
		nd.talk("is nonzero if either the pic1 pixel exceeds Athresh OR the pic2 pixel");
		nd.talk("exceeds Bthresh, in which case its output is the maximum of the ");
		nd.talk("pic1 pic2 pixels that exceeded their thresholds.");
		nd.talk("If both pic1 or pic2 are null, or if both pic1 and pic2 pixels are ");
		nd.talk("subthreshold then the output pixel is zero");
		}
		

public boolean doit(short [] inras , int incols,   int inrows, int Athresh, 
				    short [] inras2, int incols2, int inrows2, int Bthresh, short [] outras) {
		int i, npix = inrows*incols;
		short p1,p2;
		if(nd.diags) nd.talk("ThreshFltr with Athresh="+Athresh+" and Bthresh="+Bthresh);
		
		if(inras2==null) { // the or operation is still sensible
			nd.talk("Thresh_Or_Filter gets second input channel as null????");
			for(i=0;i<npix;i++)
				outras[i] = inras[i] > Athresh? inras[i] : 0;
			return false;
			}
			
		if(inras==null) { // the or operation is still sensible
			nd.talk("Thresh_Or_Filter gets first input channel as null???");
			for(i=0;i<npix;i++)
				outras[i] = inras2[i] > Bthresh? inras2[i] : 0;
			return false;
			}
			
		//if fall to here, both input channels are valid...
		for(i=0;i<npix;i++) {
			p2=inras2[i];
			if((p1=inras[i]) >= Athresh || p2 >= Bthresh) 
				outras[i] = p1<p2? p2 : p1;	
				
			else
				outras[i] = 0;
			}	
		return true;	
		}
		
}