package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.io.*;
import java.lang.*;
import java.util.*;
import java.awt.*;  import javax.swing.*;


class TiffFuncs extends JFrame{
    static byte colorvid1tail[] = 
    {(byte)0, (byte)14, (byte)1, (byte)0, (byte)0, (byte)3, (byte)0, (byte)0, (byte)0, (byte)1, (byte)3, (byte)0, (byte)0, (byte)0, (byte)1, (byte)1, (byte)0, (byte)3, (byte)0, (byte)
    (byte)0, (byte)0, (byte)1, (byte)2, (byte)0, (byte)0, (byte)0, (byte)1, (byte)2, (byte)0, (byte)3, (byte)0, (byte)0, (byte)0, (byte)3, (byte)0, (byte)18, (byte)0, (byte)182, (byte)1, (byte)3, (byte)0, (byte)3, (byte)0, (byte)0, (byte)
    (byte)0, (byte)1, (byte)0, (byte)1, (byte)0, (byte)0, (byte)1, (byte)6, (byte)0, (byte)3, (byte)0, (byte)0, (byte)0, (byte)1, (byte)0, (byte)2, (byte)0, (byte)0, (byte)1, (byte)17, (byte)0, (byte)4, (byte)0, (byte)0, (byte)0, (byte)19, (byte)
    (byte)0, (byte)18, (byte)0, (byte)188, (byte)1, (byte)18, (byte)0, (byte)3, (byte)0, (byte)0, (byte)0, (byte)1, (byte)0, (byte)1, (byte)0, (byte)0, (byte)1, (byte)21, (byte)0, (byte)3, (byte)0, (byte)0, (byte)0, (byte)1, (byte)
    (byte)0, (byte)3, (byte)0, (byte)0, (byte)1, (byte)22, (byte)0, (byte)4, (byte)0, (byte)0, (byte)0, (byte)1, (byte)0, (byte)0, (byte)0, (byte)28, (byte)1, (byte)23, (byte)0, (byte)4, (byte)0, (byte)0, (byte)0, (byte)19, (byte)
    (byte)0, (byte)18, (byte)1, (byte)8, (byte)1, (byte)24, (byte)0, (byte)3, (byte)0, (byte)0, (byte)0, (byte)3, (byte)0, (byte)18, (byte)1, (byte)84, (byte)1, (byte)25, (byte)0, (byte)3, (byte)0, (byte)0, (byte)0, (byte)3, (byte)
    (byte)0, (byte)18, (byte)1, (byte)90, (byte)1, (byte)28, (byte)0, (byte)3, (byte)0, (byte)0, (byte)0, (byte)1, (byte)0, (byte)1, (byte)0, (byte)0, (byte)1, (byte)83, (byte)0, (byte)3, (byte)0, (byte)0, (byte)0, (byte)3, (byte)
    (byte)0, (byte)18, (byte)1, (byte)96, (byte)0, (byte)0, (byte)0, (byte)0, (byte)0, (byte)8, (byte)0, (byte)8, (byte)0, (byte)8, (byte)0, (byte)0, (byte)0, (byte)8, (byte)0, (byte)0, (byte)252, (byte)8, (byte)0, (byte)1, (byte)
    (byte)248, (byte)8, (byte)0, (byte)2, (byte)244, (byte)8, (byte)0, (byte)3, (byte)240, (byte)8, (byte)0, (byte)4, (byte)236, (byte)8, (byte)0, (byte)5, (byte)232, (byte)8, (byte)0, (byte)6, (byte)228, (byte)
    (byte)8, (byte)0, (byte)7, (byte)224, (byte)8, (byte)0, (byte)8, (byte)220, (byte)8, (byte)0, (byte)9, (byte)216, (byte)8, (byte)0, (byte)10, (byte)212, (byte)8, (byte)0, (byte)11, (byte)208, (byte)8, (byte)
    (byte)0, (byte)12, (byte)204, (byte)8, (byte)0, (byte)13, (byte)200, (byte)8, (byte)0, (byte)14, (byte)196, (byte)8, (byte)0, (byte)15, (byte)192, (byte)8, (byte)0, (byte)16, (byte)188, (byte)8, (byte)0, (byte)
    (byte)17, (byte)184, (byte)8, (byte)0, (byte)0, (byte)252, (byte)0, (byte)0, (byte)0, (byte)252, (byte)0, (byte)0, (byte)0, (byte)252, (byte)0, (byte)0, (byte)0, (byte)252, (byte)0, (byte)0, (byte)0, (byte)252, (byte)
    (byte)0, (byte)0, (byte)0, (byte)252, (byte)0, (byte)0, (byte)0, (byte)252, (byte)0, (byte)0, (byte)0, (byte)252, (byte)0, (byte)0, (byte)0, (byte)252, (byte)0, (byte)0, (byte)0, (byte)252, (byte)0, (byte)0, (byte)0, (byte)
    (byte)252, (byte)0, (byte)0, (byte)0, (byte)252, (byte)0, (byte)0, (byte)0, (byte)252, (byte)0, (byte)0, (byte)0, (byte)252, (byte)0, (byte)0, (byte)0, (byte)252, (byte)0, (byte)0, (byte)0, (byte)252, (byte)0, (byte)
    (byte)0, (byte)0, (byte)252, (byte)0, (byte)0, (byte)0, (byte)252, (byte)0, (byte)0, (byte)0, (byte)72, (byte)0, (byte)0, (byte)0, (byte)0, (byte)0, (byte)0, (byte)0, (byte)0, (byte)255, (byte)0, (byte)255, (byte)0, (byte)
    (byte)255, (byte)0, (byte)1, (byte)0, (byte)1, (byte)0, (byte)1 };
 
    static byte colorheadbyte[] = {(byte)77, (byte)77, (byte)0, (byte)42, (byte)0, (byte)18, (byte)0, (byte)8};
    
    final static   int	RAWROWS = 512, RAWCOLS = 768;
    
    public void writeColor768Tiff(int [] data) throws IOException {
	RandomAccessFile tiffFile;
	if((tiffFile=openWritingFile(this,"tiff file name?")) != null)
		    writeColor768Tiff(tiffFile, data);
	}

    public static void writeColor768Tiff(String pathFileName, int [] data) {
    	RandomAccessFile out =  openWritingFile(pathFileName);
    	if(out != null) {
    		try {writeColor768Tiff(out, data);}
    		catch(IOException e) {
    			talk("failed to write file called "+pathFileName);
    			}
    		}
    	}
    	
    public static void writeColor768Tiff(RandomAccessFile out, int [] data) throws IOException {
	int	npix=RAWROWS*RAWCOLS, p, k;
	int redmask = (255 << 16);
	int greenmask = (255 << 8);
	int bluemask = 255;
	byte	[] outdata = new byte[3*npix];

	/* write out the .tiff file header */
	    try {
		out.write(colorheadbyte);
	/* write out the raster */
		k=0;
		for(int j = 0; j < npix; j++) {
		    p = data[j];
		    outdata[k++] = (byte)((p & redmask) >> 16);
		    outdata[k++] = (byte)((p & greenmask) >> 8);
		    outdata[k++] = (byte)(p & bluemask);
		}
		out.write(outdata);
		outdata=null;
	/* write out the tiff file tail. */
		out.write(colorvid1tail); 
		out.close(); 
		talk("tiff file successfully written...");
		}
	catch(IOException e) {
	    talk("tiff file write failed somehow");
	    }
    }


	static RandomAccessFile openWritingFile(JFrame theJFrame,String prompt) {
		RandomAccessFile outfile;
		FileDialog getFileToWrite = 
		   new FileDialog(theJFrame,prompt, FileDialog.SAVE);
		getFileToWrite.show();
		String filename = getFileToWrite.getDirectory()+"/"+getFileToWrite.getFile();
		if(filename == null) return null;
		try{
			outfile = new RandomAccessFile(filename,"rw");
			}
		catch (IOException e) {
			talk("openWritingFile("+prompt+") failed");
			return null;
			}
		try{outfile.seek((long)0);}
		catch(IOException e) {};
		return outfile;
		}
		
	static RandomAccessFile openWritingFile(String pathFileName) {
		RandomAccessFile outfile;
		try{
			outfile = new RandomAccessFile(pathFileName,"rw");
			}
		catch (IOException e) {
			talk("openWritingFile("+pathFileName+") failed");
			return null;
			}
		try{outfile.seek((long)0);}
		catch(IOException e) {};
		return outfile;
		}
		
	static void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}
}
