package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.*;  
import javax.swing.*;
import java.util.*;
import java.io.*;

public class Tools{  /* holds global static data and methods */

	static void talk(String stg) { // write a line on stdout
		System.out.println("SIM>>> "+stg);
		}
			
	static boolean yesNo (String question, String trueAns, String falseAns,
			Color backcol) {
		boolean answer=false;
		AnsBuf theans = new AnsBuf();
		theans.iwh=1;
		Query query = new Query(question, trueAns, falseAns, theans, backcol);
				
		queryThread thr1 = new queryThread(theans);		
		
		try{
			thr1.t.join();
			}
		catch (InterruptedException e) {}
		answer=theans.booleanAns;
		//System.out.println("It finished, and the answer is "+ theans.answer);
		query.off();
		theans=null;
		return answer;		
	}
	

	static double getDouble(String question, double valueNow, Color backcol) {
		double answer=0.;
		AnsBuf theans = new AnsBuf();
		theans.iwh=2;
		theans.doubleAns = valueNow;
		Query query = new Query(question, theans, backcol);
				
		queryThread thr1 = new queryThread(theans);		
		
		try{
			thr1.t.join();
			}
		catch (InterruptedException e) {}
		answer=theans.doubleAns;
		query.off();
		theans=null;
		return answer;		
	}
	
	static long getLong (String question, long valueNow, Color backcol) {
		long answer=0;
		AnsBuf theans = new AnsBuf();
		theans.iwh=4;
		theans.longAns = valueNow;
		Query query = new Query(question, theans, backcol);
				
		queryThread thr1 = new queryThread(theans);		
		
		try{
			thr1.t.join();
			}
		catch (InterruptedException e) {}
		answer=theans.longAns;
		query.off();
		theans=null;
		return answer;		
	}
	
	static String getString (String question, Color backcol) {
		String answer="";
		AnsBuf theans = new AnsBuf();
		theans.iwh=3;
		Query query = new Query(question, theans, backcol);
				
		queryThread thr1 = new queryThread(theans);		
		
		try{
			thr1.t.join();
			}
		catch (InterruptedException e) {}
		answer=theans.stringAns;
		query.off();
		theans=null;
		return answer;		
	}

	static String boil(long checkSum,boolean ifxform,String fname) {
		int i,j;
		char achar=' ';
		String boiled="";
		String typeable = 
		   "abcdeCDEFGHIfghijklmMNOvwxyz012345nopTUVWXYZ-_qrstu6789ABJKLPQRS";
		int ntype = typeable.length();
		
		int nchars = fname.length();
		if(!ifxform) nchars -= 4;
		for(i=nchars-1;i>=0;i--) {
			achar = fname.charAt(i);
			if((j=typeable.indexOf(achar)) >=0) {
				if((checkSum % 2) >0)
					achar = typeable.charAt(ntype-1-j);
				checkSum = checkSum/2;
				}
			boiled += achar;
			}
		if(ifxform) 
			boiled += ".tar";
		
		return (boiled);					
		}
	
}