package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.io.*;
import java.lang.*;
import java.util.*;
import java.awt.*;  
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.plaf.metal.*;
			

class WidgetMaker extends JFrame {
/* for making buttons, tgextfields, labels, etc and assigning a common font etc.
	WidgetMaker wmk = new WidgetMaker(this);
*/
    Font alp = new Font("application",Font.PLAIN,9);
    Insets nomargins = new Insets(0,0,0,0);
    Object parent;
    java.awt.event.ActionListener parentActionListener=null;
    java.awt.event.ItemListener parentItemListener=null;
	Color lightred = new Color(255,150,150);
	Color lightgreen = new Color(150,255,150);
	Color lightblue = new Color(150,150,255);
 
 public WidgetMaker(Object parentThatImplementsActionListener) { 
 	this.parent = parentThatImplementsActionListener;
   	try { // this gives the same look and feel to every component widgetMaker returns.
		MetalLookAndFeel tLF = new MetalLookAndFeel();
   		UIManager.setLookAndFeel(tLF);
    	}
    catch(Exception ex){
   		System.out.println("in widgetMaker(), UIManager.setLookAndFeel did not work $$$$$$$$$$$$$$"+ex);
    	}
 	}
 		
	static void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}

	public JComboBox makeAJComboBox(String [] theStrings) {
		int nchoices = theStrings.length;
		return makeAJComboBox(nchoices, theStrings);
		}
		
	public JComboBox makeAJComboBox(int nchoices, String [] theStrings) {
		String [] comboObj = new String[nchoices];
		for(int i=0;i<nchoices;i++) 
			comboObj[i] = new String(theStrings[i]);
		JComboBox combo = new JComboBox(comboObj);
		combo.setFont(alp);
		combo.addItemListener((java.awt.event.ItemListener )parent);
		combo.setMaximumRowCount(nchoices);
		combo.setLightWeightPopupEnabled(false);
		return combo;
		} 
		
	public JButton makeAJButton(String lab) {
		JButton bt = new JButton(lab);
		bt.setFont(alp);
		bt.setMargin(nomargins);
		bt.addActionListener((java.awt.event.ActionListener )parent);
		return bt;
		}
		
	public JButton makeAJButton(String lab, Color col) {
		JButton bt = new JButton(lab);
		bt.setFont(alp);
		bt.setMargin(nomargins);
		bt.setBackground(col);
		bt.addActionListener((java.awt.event.ActionListener )parent);
		return bt;
		}
		
	public JButton makeAJButton(String lab, int r, int g, int b) {
		return makeAJButton(lab, new Color(r,g,b));
		}
		
  	public JMenuItem makeAJMenuItem(String lab) {
		JMenuItem itm = new JMenuItem(lab);
		itm.setFont(alp);
		itm.addActionListener((java.awt.event.ActionListener )parent);
		itm.setMargin(nomargins);
		return itm;
		}
		
	public JLabel makeAJLabel(String lab,int where) {
		JLabel lb = new JLabel(lab,where);
		lb.setFont(alp);
		return lb;
		}
		
	public JLabel makeAJLabel(String lab) {
		JLabel lb = new JLabel(lab);
		lb.setFont(alp);
		return lb;
		}
		
	public JLabel makeAJLabel(String lab,Color col) {
		JLabel lb = new JLabel(lab);
		lb.setForeground(col);
		lb.setFont(alp);
		return lb;
		}
				
	public JLabel makeAJLabel(String lab, int where, Color col) {
		JLabel lb = new JLabel(lab,where);
		lb.setForeground(col);
		lb.setFont(alp);
		return lb;
		}
		
	public JTextField makeAJTextField(String lab, int width) {
		JTextField tf = new JTextField(lab, width);
		tf.setFont(alp);
		tf.setMargin(nomargins);
		return tf;
		}

	public JTextField makeAJTextField(String lab, int width, int r, int g, int b) {
		return (makeAJTextField(lab, width, new Color(r,g,b)));
		}
		
	public JTextField makeAJTextField(String lab, int width, Color col) {
		JTextField tf = new JTextField(lab, width);
		tf.setFont(alp);
		tf.setMargin(nomargins);
		tf.setBackground(col);
		return tf;
		}

  }		

	 
