package staxx;
import java.io.*;
import java.lang.*;
import java.util.*;
import java.awt.*;  import javax.swing.*;


class writePointSpreadFile extends JFrame implements java.awt.event.ActionListener,java.awt.event.WindowListener {
	ShowPicJPanel picJPanel;
	PointSpreadCanvasFrame canvasFrame=null;
	DeconvolverPSF DPSF;
	int nomwidth=500, nomheight=170;
	JTextField xfield,yfield,zfield,beadSearchRadField,dimThreshField,profileReportField,activeMarkerField;
	JTextField maxradfield,maxzdepthfield,dxyfield,dzfield,beadDiameterField,delzLimitsField;
	int xcen=55,ycen=283,zcen=210,beadSearchRad=5,rgbchan = 0; // integer indices
	double dxy=.5,dz=.2,maxrad=5.,maxdepth=5.,beadDiameter=.50,dimThresh=0.,delzLim=5.0; // in microns
	JButton rgbButton,tellProfileButton,writeButton;
	BioradFile fileToUse=null;
	WidgetMaker wmk;
	boolean [] ifcached;
	byte [][] cacheras; // for cacheing the sections
	
	int [][]histoProfile;
	int [][]countsProfile;
	double [][] radProfile;
	double [][] oopsProfile;
	int nradpts=10,numProfiles=2,lowSectNum = 0, highSectNum=1, minsect=0,maxsect=1;
	boolean profilesAreReady = false;
	int totalLightInBead=0;
	
	int activeMarker=1;
	
	public void sepuku() { // for releasing all storage
		canvasFrame.sepuku();
		histoProfile=null;
		countsProfile=null;
		radProfile=null;
		oopsProfile=null;
		ifcached=null;
		cacheras=null;
		picJPanel.parent.writePSF=null;
		picJPanel=null;
		dispose();
		}
		
	private boolean isDataFileActive() {
		if(fileToUse == null) {
			talk("Cannot do that because no bio-rad data file is active.");
			return false;
			}
		else return true;
		}
		
	public void readFromDisk(ArchiveMarks reader) {
		String stg;
		boolean headerComplete=false,dataComplete=false;
		int i,j;

		while(!headerComplete && (stg = reader.readOneLine()) != null) {
			if(stg.indexOf("@EndOfHeader") >= 0)
				headerComplete=true;
			else if(stg.indexOf("@")>=0) { // parse one header line
			
				if(stg.indexOf("@filename")>=0) {
					i=1+stg.indexOf("=");
					talk("The file name from which these profiles were measured is:");
					talk(stg.substring(i,stg.length()));
					}


				if(stg.indexOf("@x center of light source")>=0) {
					i=1+stg.indexOf("=");
					xcen = (int)(Double.valueOf(stg.substring(i,stg.length())).doubleValue());
					}
					
				if(stg.indexOf("@y center of light source")>=0) {
					i=1+stg.indexOf("=");
					ycen = (int)(Double.valueOf(stg.substring(i,stg.length())).doubleValue());
					}
					
				if(stg.indexOf("@z center section of light source")>=0) {
					i=1+stg.indexOf("=");
					zcen = (int)(Double.valueOf(stg.substring(i,stg.length())).doubleValue());
					}
					
				if(stg.indexOf("@bead search radius")>=0) {
					i=1+stg.indexOf("=");
					beadSearchRad = (int)(Double.valueOf(stg.substring(i,stg.length())).doubleValue());
					}
					
				if(stg.indexOf("@bead diameter (microns)")>=0) {
					i=1+stg.indexOf("=");
					beadDiameter = Double.valueOf(stg.substring(i,stg.length())).doubleValue();
					}
					
				if(stg.indexOf("@dimThreshold")>=0) {
					i=1+stg.indexOf("=");
					dimThresh = Double.valueOf(stg.substring(i,stg.length())).doubleValue();
					}
					
				if(stg.indexOf("@max cone radius surveyed from center")>=0) {
					i=1+stg.indexOf("=");
					maxrad = Double.valueOf(stg.substring(i,stg.length())).doubleValue();
					}
					
				if(stg.indexOf("@max cone z-depth surveyed from center ")>=0) {
					i=1+stg.indexOf("=");
					maxdepth = Double.valueOf(stg.substring(i,stg.length())).doubleValue();
					}
					
				if(stg.indexOf("@z-depth cutoff chosen by user")>=0) {
					i=1+stg.indexOf("=");
					delzLim = Double.valueOf(stg.substring(i,stg.length())).doubleValue();
					}
					
				if(stg.indexOf("@lowest section number recorded")>=0) {
					i=1+stg.indexOf("=");
					minsect = (int)(Double.valueOf(stg.substring(i,stg.length())).doubleValue());
					}
					
				if(stg.indexOf("@highest  section number recorded")>=0) {
					i=1+stg.indexOf("=");
					maxsect = (int)(Double.valueOf(stg.substring(i,stg.length())).doubleValue());
					}
					
				if(stg.indexOf("@maximum number of radius cells recorded")>=0) {
					i=1+stg.indexOf("=");
					nradpts = 1+ (int)(Double.valueOf(stg.substring(i,stg.length())).doubleValue());
					}
						
				if(stg.indexOf("@pixel width (microns)")>=0) {
					i=1+stg.indexOf("=");
					dxy = Double.valueOf(stg.substring(i,stg.length())).doubleValue();
					}
					
				if(stg.indexOf("@section thickness (microns)")>=0) {
					i=1+stg.indexOf("=");
					dz = Double.valueOf(stg.substring(i,stg.length())).doubleValue();
					}
					
				if(stg.indexOf("@rgb channel number")>=0) {
					i=1+stg.indexOf("=");
					rgbchan = (int)(Double.valueOf(stg.substring(i,stg.length())).doubleValue());
					}
				}	
			} // end of section that parses the header.
		
		// put all the header info into the appropriate variables
			xfield.setText((""+xcen));
			yfield.setText((""+ycen));
			zfield.setText((""+zcen));
			beadSearchRadField.setText((""+beadSearchRad));
			dimThreshField.setText((trunc(dimThresh)));
			setDelzLim(delzLim);
			if(maxdepth>delzLim) 
				maxdepth = delzLim;
			beadDiameterField.setText((trunc(beadDiameter)));
			maxradfield.setText((trunc(maxrad)));
			maxzdepthfield.setText((trunc(maxdepth)));
			dxyfield.setText((trunc(dxy)));
			dzfield.setText((trunc(dz)));
			if(rgbchan==0) 	
				rgbButton.setText("use red file");
			if(rgbchan==1) 	
				rgbButton.setText("use green file");
			if(rgbchan==2) 	
				rgbButton.setText("use blue file");
			
			lowSectNum = minsect; 
			highSectNum=maxsect;
		// make the profiles array
			numProfiles = maxsect-minsect+1;
			radProfile  =  new double[numProfiles][nradpts];
			oopsProfile = new double[numProfiles][nradpts];
			for(i=0;i<numProfiles;i++)
				for(j=0;j<nradpts;j++) {
					radProfile[i][j]=0;
					oopsProfile[i][j]=0;
					}
		while(headerComplete && !dataComplete && (stg = reader.readOneLine()) != null) {
			if(stg.indexOf("@EndOfFile") >= 0)
				dataComplete=true;
			else if(stg.indexOf("iz=") >=0)
				parseDataString(stg);
				
			}
		canvasFrame.newSlate(radProfile,nradpts,numProfiles);
		canvasFrame.showYourself(true); // make the profiles just read in visible
		}

		private boolean parseDataString(String stg) {
			int i1 = 3+stg.indexOf("iz=");
			int j1 = stg.indexOf("delz=")-1;
			
			int i2 = j1+6;
			int j2 = stg.indexOf("ir=")-1;
			
			int i3 = j2+4;
			int j3 = stg.indexOf("rad=")-1;
			
			int i4 = j3 + 5;
			int j4 = stg.indexOf("glow=")-1;
			
			int i5 = j4+6;
			int j5 = stg.length();
	/*		                   i1      i2        i3    i4          i5
	   the typical line is <iz=60 delz=2.9000 ir=3 rad=0.2974 glow=2.3898>
	                             j1          j2   j3         j4          j5  */
			
			String st1 = stg.substring(i1,j1);
			String st2 = stg.substring(i2,j2);
			String st3 = stg.substring(i3,j3);
			String st4 = stg.substring(i4,j4);
			String st5 = stg.substring(i5,j5);
			/* talk(stg);
			talk(st1+" , "+st2+" , "+st3+" , "+st4+" , "+st5); */
			int iz = (int)(Double.valueOf(st1).doubleValue());
			double delz = Double.valueOf(st2).doubleValue();
			int ir = (int)(Double.valueOf(st3).doubleValue());
			double rad = Double.valueOf(st4).doubleValue();
			double glow = Double.valueOf(st5).doubleValue();
			boolean lineIsGood=true;
			if(iz<0 || iz >= numProfiles) {
				talk("bad iz = "+iz);
				lineIsGood=false;
				}
			if(ir>=nradpts) {
				talk("bad ir = "+ir);
				lineIsGood=false;
				}
				
			if(!lineIsGood) {
				talk("     in data line: "+stg);
				return false;
				}
			else { // collect the data
				radProfile[iz][ir]=glow;
				oopsProfile[iz][ir]=glow;
				return true;
				}
			}	
			
				
	private void storeOopsProfiles(int iwh) {
		int iz,k;
		if(iwh==1)  // transfer radProfile to oopsProfile
			for(iz=0;iz<numProfiles;iz++)
				for(k=0;k<nradpts;k++)
					oopsProfile[iz][k] = radProfile[iz][k];
		if(iwh==2)  // recover from oopsProfile
			for(iz=0;iz<numProfiles;iz++)
				for(k=0;k<nradpts;k++)
					radProfile[iz][k] = oopsProfile[iz][k];
		}
	
	public double tellZ(int iz) {
		int theSect = iz + lowSectNum;
		return ((theSect-zcen)*dz);
		}
		
	public void reportProfile(double zzz) {
		profileReportField.setText(trunc(zzz));
		}
		
	public double getDimThresh() {
		dimThresh = Double.valueOf(dimThreshField.getText()).doubleValue();
		if(dimThresh<0) dimThresh=0;
		if(dimThresh>=100) dimThresh = 100;	
		dimThreshField.setText((trunc(dimThresh)));
		return dimThresh;
		}
		
	private double getDelzLim() {
		delzLim = Double.valueOf(delzLimitsField.getText()).doubleValue();
		if(delzLim<0) delzLim=0;
		if(delzLim>=maxdepth) delzLim = maxdepth;	
		delzLimitsField.setText(trunc(delzLim));
		return delzLim;
		}
				
	private void setDelzLim(double dzlm) {
		delzLimitsField.setText(trunc(dzlm));
		}
	
	private double [] goToActiveMarker() {
		if(!isDataFileActive()) {
			double [] abc = {0,0,0};
			return abc;
			}
		picJPanel.goToMarker(activeMarker);
		picJPanel.parent.goJPanel.setVisible(true);
		double [] xyz = picJPanel.marks[activeMarker].tellAbsLoc();
		return xyz;
		}
		
	private void moveActiveMarkerTo(double [] xyz) {
		if(!isDataFileActive()) return;
		picJPanel.marks[activeMarker].moveTo(xyz);
		goToActiveMarker();
		}
					
	private void readTextFields() {
		xcen = (int)(Double.valueOf(xfield.getText()).doubleValue());
		if(xcen<0) xcen=0;
		if(xcen>=fileToUse.width) xcen = fileToUse.width-1;	
		xfield.setText((""+xcen));
		
		ycen = (int)(Double.valueOf(yfield.getText()).doubleValue());
		if(ycen<0) ycen=0;
		if(ycen>=fileToUse.height) ycen = fileToUse.height-1;	
		yfield.setText((""+ycen));
		
		zcen = (int)(Double.valueOf(zfield.getText()).doubleValue());
		if(zcen<0) zcen=0;
		if(zcen>=fileToUse.num_pics) zcen = fileToUse.num_pics-1;	
		zfield.setText((""+zcen));
		
		beadSearchRad = (int)(Double.valueOf(beadSearchRadField.getText()).doubleValue());
		if(beadSearchRad<5) beadSearchRad=5;
		if(beadSearchRad>=50) beadSearchRad = 50;	
		beadSearchRadField.setText((""+beadSearchRad));
		
		// Those were the integer parameters. Now get the doubles.
		getDimThresh();
		getDelzLim();
		
		beadDiameter = Double.valueOf(beadDiameterField.getText()).doubleValue();
		if(beadDiameter<.01) beadDiameter=.01;
		if(beadDiameter>=10) beadDiameter = 10;	
		beadDiameterField.setText((trunc(beadDiameter)));

		maxrad = Double.valueOf(maxradfield.getText()).doubleValue();
		if(maxrad<3.0) maxrad=3.00;
		if(maxrad> fileToUse.height/2) 
			maxrad = fileToUse.height/2.0;	
		maxradfield.setText((trunc(maxrad)));
		
		maxdepth = Double.valueOf(maxzdepthfield.getText()).doubleValue();
		if(maxdepth<3.0) maxdepth=3.00;
		if(maxdepth > fileToUse.num_pics) maxdepth = fileToUse.num_pics-1.;	
		maxzdepthfield.setText((trunc(maxdepth)));
		
		getVoxelSize();
		}
		
	private void getVoxelSize() {
		if(!isDataFileActive()) return;
			
		if(fileToUse.dxy<0) { 
			talk("Bad value of size in microns of xy pixels in the biorad file");
			dxy = .5;
			}
		else dxy = fileToUse.dxy;
		dxyfield.setText((trunc(dxy)));
		
		if(fileToUse.dz<0) { 
			talk("Bad value of thickness of sections in microns in the biorad file");
			dz = .5;
			}
		else dz = fileToUse.dz;
		dzfield.setText((trunc(dz)));		
		}

    public writePointSpreadFile(ShowPicJPanel picJPanel) {   
    super("pointSpreadFileWriter");
    this.picJPanel=picJPanel;
	canvasFrame = new PointSpreadCanvasFrame(this);
    getContentPane().setLayout(new BorderLayout()); 
    setSize(nomwidth, nomheight);
	int rr=0,gg=128,bb=0;
	 
	wmk = new WidgetMaker(this); // this persists forever
	JPanel westpanel  = new JPanel();
	westpanel.setLayout(new GridLayout(0,1));

	JPanel buttonPanel3 = new JPanel();
	buttonPanel3.setLayout(new GridLayout(1,3));
	buttonPanel3.add(wmk.makeAJButton("set |deltaz| limits->"));
	delzLim = maxdepth;
	delzLimitsField = wmk.makeAJTextField(""+delzLim, 40);
	buttonPanel3.add(delzLimitsField);
	buttonPanel3.add(wmk.makeAJButton("read profiles from disk"));
	westpanel.add(buttonPanel3);
	
	JPanel buttonPanel4 = new JPanel();
	buttonPanel4.setLayout(new GridLayout(1,3));
	buttonPanel4.add(wmk.makeAJButton("-- active marker")); 
	activeMarkerField = wmk.makeAJTextField(""+activeMarker, 40);
	buttonPanel4.add(activeMarkerField);
	buttonPanel4.add(wmk.makeAJButton("++ activeMarker"));
	westpanel.add(buttonPanel4);
	
	JPanel buttonPanel5 = new JPanel();
	buttonPanel5.setLayout(new GridLayout(1,3));
	buttonPanel5.add(wmk.makeAJButton("get bead loc from active marker"));
	buttonPanel5.add(wmk.makeAJButton("store bead loc in active marker"));
	buttonPanel5.add(wmk.makeAJButton("load deconvolver PSF object"));
	westpanel.add(buttonPanel5);
	
	JPanel centerPanel = new JPanel();
	centerPanel.setLayout(new GridLayout(1,4));
	centerPanel.add(wmk.makeAJLabel("bead x   y   z  =", new Color(rr,gg,bb)));
	xfield = wmk.makeAJTextField(""+xcen, 40);
	centerPanel.add(xfield);
	yfield = wmk.makeAJTextField(""+ycen, 40);
	centerPanel.add(yfield);
	zfield = wmk.makeAJTextField(""+zcen, 40);
	centerPanel.add(zfield);
	westpanel.add(centerPanel);
	
	JPanel bPanel = new JPanel();
	bPanel.setLayout(new GridLayout(1,4));
	bPanel.add(wmk.makeAJLabel("bead dia,microns=", new Color(rr,gg,bb)));
	beadDiameterField = wmk.makeAJTextField(""+beadDiameter, 40);
	bPanel.add(beadDiameterField);
	bPanel.add(wmk.makeAJLabel("beadSearchRad,pixels=", new Color(rr,gg,bb)));
	beadSearchRadField = wmk.makeAJTextField(""+beadSearchRad, 40);
	bPanel.add(beadSearchRadField);
	westpanel.add(bPanel);
		
	JPanel dPanel = new JPanel();
	dPanel.setLayout(new GridLayout(1,4));
	dPanel.add(wmk.makeAJLabel("lightConeRad,microns=", new Color(rr,gg,bb)));
	maxradfield = wmk.makeAJTextField(""+maxrad, 40);
	dPanel.add(maxradfield);	
	dPanel.add(wmk.makeAJLabel("lightConeZDepth,microns=", new Color(rr,gg,bb)));
	maxzdepthfield = wmk.makeAJTextField(""+maxdepth, 40);
	dPanel.add(maxzdepthfield);
	westpanel.add(dPanel);
	
	JPanel fPanel = new JPanel();
	fPanel.setLayout(new GridLayout(1,4));
	fPanel.add(wmk.makeAJLabel("pixWidth,microns=", new Color(rr,gg,bb)));
	dxyfield = wmk.makeAJTextField(""+dxy, 40);
	fPanel.add(dxyfield);
	fPanel.add(wmk.makeAJLabel("sectThickness,microns=", new Color(rr,gg,bb)));
	dzfield = wmk.makeAJTextField(""+dz, 40);
	fPanel.add(dzfield);
	westpanel.add(fPanel);

	JPanel gPanel = new JPanel();
	gPanel.setLayout(new GridLayout(1,4));
	gPanel.add(wmk.makeAJLabel("dim threshold =", new Color(rr,gg,bb)));
	dimThreshField = wmk.makeAJTextField(""+dimThresh, 40);
	gPanel.add(dimThreshField);
	tellProfileButton = wmk.makeAJButton("drawn profile @ |deltaz|=");
	gPanel.add(tellProfileButton);
	profileReportField = wmk.makeAJTextField("-77", 40);
	gPanel.add(profileReportField);
	westpanel.add(gPanel);

	JPanel buttonPanel2 = new JPanel();
	buttonPanel2.setLayout(new GridLayout(1,4));
	buttonPanel2.add(wmk.makeAJButton("undo last operation->"));
	buttonPanel2.add(wmk.makeAJButton("make profiles monotone"));
	buttonPanel2.add(wmk.makeAJButton("smooth each profile"));
	buttonPanel2.add(wmk.makeAJButton("blend adjacent profiles"));
	westpanel.add(buttonPanel2);
		
	JPanel buttonPanel1 = new JPanel();
	buttonPanel1.setLayout(new GridLayout(1,4));
	rgbButton = wmk.makeAJButton("use red file");
	fileToUse = picJPanel.redfile;
	rgbchan = 0;
	buttonPanel1.add(rgbButton);	
	buttonPanel1.add(wmk.makeAJButton("find bead center"));
	buttonPanel1.add(wmk.makeAJButton("compute profiles"));
	writeButton = wmk.makeAJButton("      ");
	buttonPanel1.add(writeButton);
	westpanel.add(buttonPanel1);
	
	getContentPane().add("Center",westpanel);
	addWindowListener(this);
	getVoxelSize();
  }

	
// catch WindowListener events  
	public void windowActivated(java.awt.event.WindowEvent event) {
		// talk("window activated");
		}
	public void windowDeactivated(java.awt.event.WindowEvent event) {
		//  talk("window Deactivated");
		}
	public void windowOpened(java.awt.event.WindowEvent event) {}
	public void windowIconified(java.awt.event.WindowEvent event) {}
	public void windowDeiconified(java.awt.event.WindowEvent event) {}
	public void windowClosing(java.awt.event.WindowEvent event) {
	    setVisible(false);
		sepuku();
		dispose();
		}
	public void windowClosed(java.awt.event.WindowEvent event) {
		}	 

// catch button and menu events...
	public void actionPerformed(java.awt.event.ActionEvent event) {
		String arg = event.getActionCommand();
		int i;
		if(arg.equals("write profiles to disk") || arg.equals("find bead center") ||
					arg.equals("compute profiles")) {
			int iwh=0;
			if(fileToUse == null) {
				for(i=0;i<10;i++)
					talk("The input channel file is null. cannot proceed until you fix that");
				return;
				}
			if(arg.equals("write profiles to disk")) {
				iwh =0; // means really write the file to disk
				if(!profilesAreReady) {
					talk("Before writing the profiles to disk, you must first"); 
					talk("click the 'draw profiles' button to compute the profiles");
					return;
					}
				}					
			else if(arg.equals("find bead center")) {
				if(!isDataFileActive()) return;
				iwh =1; // means just locate bead center
				}
			else if(arg.equals("compute profiles")) {
				if(!isDataFileActive()) return;
				iwh=2; // means compute and draw profiles
				}
			else return;
			
			readTextFields();
			writeTheFile(iwh);
			if(arg.equals("compute profiles")) {
				canvasFrame.newSlate(radProfile,nradpts,numProfiles);
				canvasFrame.showYourself(true); // the profiles have been computed and
					// so can be drawn.
				}
			if(iwh>0) { // just recomputed the bead's center
				double [] xyz = {xcen,ycen,zcen};
				moveActiveMarkerTo(xyz);
				}
			histoProfile=null; // free the storage space.
			countsProfile=null;
			return;
			}
		
		if(arg.equals("set |deltaz| limits->")) {
			setDelzLim(canvasFrame.getCurrentZheight()); 
			return;
			}

		if(arg.equals("read profiles from disk")) {
			talk("read profiles from disk"); 
			ArchiveMarks reader = new ArchiveMarks();
			if(!reader.readPointSpreadProfiles(this))
				talk("That did not work...");
			return;
			}

		if(arg.equals("load deconvolver PSF object")) {
			talk("load deconvolver PSF object"); 
			DPSF = new DeconvolverPSF(radProfile,nradpts,numProfiles, numProfiles/2,
				 dxy,  dz,  dxy,  dz);
			picJPanel.parent.DPSF=DPSF;
			return;
			}

		if(arg.equals("++ activeMarker")) {
			if((++activeMarker) > 10)
				activeMarker=1; 
			activeMarkerField.setText(""+activeMarker);
			return;
			}

		if(arg.equals("-- active marker")) {
			if((--activeMarker) <1)
				activeMarker=10; 
			activeMarkerField.setText(""+activeMarker);
			return;
			}

		if(arg.equals("get bead loc from active marker")) {
			if(!isDataFileActive()) return;
			double [] xyz = goToActiveMarker();
			xcen = (int)(.49+xyz[0]);
			ycen = (int)(.49+xyz[1]);
			zcen = (int)(.49+xyz[2]);
			announceNewBeadCenter();
			return;
			}

		if(arg.equals("store bead loc in active marker")) {
			if(!isDataFileActive()) return;
			readTextFields();
			double [] xyz = {xcen,ycen,zcen};
			moveActiveMarkerTo(xyz);
			return;
			}

		if(arg.equals("use red file")) {
			if(!isDataFileActive()) return;
			rgbButton.setText("use green file");
			fileToUse = picJPanel.greenfile;
			rgbchan = 1;
			getVoxelSize();
			restartSectionCache(fileToUse.num_pics);
			return;
			}

		if(arg.equals("use green file")) {
			if(!isDataFileActive()) return;
			rgbButton.setText("use blue file");
			fileToUse = picJPanel.bluefile;
			rgbchan = 2;
			getVoxelSize();
			restartSectionCache(fileToUse.num_pics);
			return;
			}

		if(arg.equals("use blue file")) {
			if(!isDataFileActive()) return;
			rgbButton.setText("use red file");
			fileToUse = picJPanel.redfile;
			rgbchan = 0;
			getVoxelSize();
			restartSectionCache(fileToUse.num_pics);
			return;
			}

		if(arg.equals("undo last operation->")) {
			if(!profilesAreReady) {
				talk("first compute/draw the profiles");
				return;
				}
			storeOopsProfiles(2);
			talk("undo last operation->");
			canvasFrame.repaint();
			return;
			}

		if(arg.equals("blend adjacent profiles")) {
			if(!profilesAreReady) {
				talk("first compute/draw the profiles");
				return;
				}
			storeOopsProfiles(1);
			talk("blend adjacent profiles");
			blendAdjacentProfiles();
			canvasFrame.repaint();
			return;
			}

		if(arg.equals("smooth each profile")) {
			if(!profilesAreReady) {
				talk("first compute/draw the profiles");
				return;
				}
			storeOopsProfiles(1);  
			talk("smooth each profile");
			for(i=0;i<numProfiles;i++)
				lowPassFilter(radProfile[i], nradpts);
			canvasFrame.repaint();
			return;
			}

		if(arg.equals("make profiles monotone")) {
			if(!profilesAreReady) {
				talk("first compute/draw the profiles");
				return;
				}
			storeOopsProfiles(1);
			talk("make profiles monotone");
			for(i=0;i<numProfiles;i++)
				makeProfileMonotone(radProfile[i], nradpts);
			canvasFrame.repaint();
			return;
			}
    }

	private void writeTheFile(int iwh) {
		talk("x center of light source= "+xcen);
		talk("y center of light source= "+ycen);
		talk("z center section of light source= "+zcen);
		talk("bright source threshold = "+beadSearchRad);
		talk("bead diameter (microns) = "+beadDiameter);
		talk("max radius from center (microns)= "+maxrad);
		talk("max z-depth from center (microns)= "+maxdepth);
		talk("pixel width (microns)= "+dxy);
		talk("section thickness (microns)= "+dz);
		talk("Now make and write the file...");
		ArchiveMarks wri = new ArchiveMarks();
		wri.writePointSpreadData(this,iwh);
		}
		
	public String trunc(double num) {
		// example num = -1023.1234567
		String stg = num <0.? "-" : ""; // stg = "-"
		num = Math.abs(num); // 1023.1234567
		int integralPart = (int)num; // 1023
		double remainder = num - integralPart; // 0.1234567
		int fourRemDigits = (int)(10000.*remainder); // 1234
		if(fourRemDigits==0) return (stg+integralPart+".0000");
		else if(fourRemDigits < 10)    return (stg+integralPart+".000"+fourRemDigits);
		else if(fourRemDigits < 100)   return (stg+integralPart+".00"+fourRemDigits);
		else if(fourRemDigits < 1000)  return (stg+integralPart+".0"+fourRemDigits);
		else return (stg+integralPart+"."+fourRemDigits);
		}
		
	private byte [] getsection(int secnum) {
		if(!isDataFileActive()) {
			byte [] nby = {0,0,0};
			return nby;
			}
		if(!ifcached[secnum]) {
			talk("read and cache section "+(secnum));								
			cacheras[secnum] = fileToUse.readBioradRaster(secnum);
			ifcached[secnum]=true;
			}
		return cacheras[secnum];
		}		
		
	private int [] findBeadCenter(int xyexplore,int zexplore,int xcn,
			int ycn,int zcn,int minsect,int maxsect,int minrow,int maxrow,
				int mincol,int maxcol,int raswidth, int rasheight, int nsections) {
			int ix,iy,iz,sum;
			int [] retn = {xcn,ycn,zcn,0};
			if(!isDataFileActive()) 
				return retn;
				
			if(zcn+2*zexplore >= nsections || zcn-2*zexplore <0 ||
				xcn+2*xyexplore >= raswidth || xcn+2*xyexplore <0 ||
					ycn + 2*xyexplore >= rasheight || ycn+2*xyexplore <0) {
						talk("The bead is too close to the data cube edge to refine its position.");
						return retn;
						}
			int bestsum = getsum(xcn,ycn,zcn,xyexplore,zexplore,raswidth);
			retn[3]=bestsum;
			// return a better estimate of where the bead is centered than (xcn,ycn,zcn)
			for(iz=-zexplore; iz  <= zexplore; iz++) {
				for(ix=-xyexplore; ix  <= xyexplore; ix++)
					for(iy=-xyexplore; iy  <= xyexplore; iy++)  {
					sum = getsum((xcen + ix),(ycen + iy),(zcen + iz),xyexplore,zexplore,raswidth);
					if(sum > bestsum) {
						bestsum = sum;
						retn[3]=bestsum;
						retn[0] = (xcen + ix);
						retn[1] = (ycen + iy);
						retn[2] = (zcen + iz);
						}
								
			}
		}
		return retn;
		}
		
	private int getsum(int icx, int icy, int icz,int xyexp,int zexp,int raswidth) {
		long sum=0;
		int i,j,k,pix;
		byte [] picras;
		for(k= -zexp; k <= zexp; k++) {
			picras = getsection(icz+k);
			for(i = -xyexp;i <= xyexp; i++)
				for(j = -xyexp; j <= xyexp; j++) {
					if((pix = picras[(icy+j)*raswidth + (icx+i)]) < 0)
						pix += 256;
						sum += pix*centerWeight(i,j,k);
					}
			}
		return (int)(sum/255);
		}
			
	private int centerWeight(int idx,int idy,int idz) {
		if(idz<0) idz = -idz;
		int irad = (int)(.49 + Math.sqrt(idx*idx +idy*idy));
		int wt = 255 - 4*idz - 6*irad;
		if(wt<90) wt = 90;
		return wt;		
		}
		
	private void restartSectionCache(int nsect) {
		ifcached = new boolean[nsect];
		cacheras = new byte[nsect][]; // we have to cache the sections
		for(int i=0;i<nsect;i++)
			ifcached[i]=false;
		}
	
	private void announceNewBeadCenter() {
		xfield.setText((""+xcen));
		yfield.setText((""+ycen));
		zfield.setText((""+zcen));
		}

	public void writeToDisk(ArchiveMarks writer, int iwh) {
		int ifsource = 1;
		byte [] ras;
		int width = fileToUse.width, height = fileToUse.height, nsect = fileToUse.num_pics,
			row, col, sect,minrow=0,maxrow=1,mincol=0,maxcol=1;
		double delz,delx,dely,radsq;
		double coneradsq = maxrad*maxrad;
		double beadRadius = .5*beadDiameter;
		double sphericalRadSq,howbright,beadRadiusSq = beadRadius*beadRadius;
		boolean centerIsCentered = false;
		
		int pix,irad,iz;
		String stg;
		// find the center of the bead
		int [] xyzcen;
/* Here we make a histogram for every z-section that is in the stack. 		
Then we write the histograms to the file. The r-resolution in the histograms
should be equal to dxy, and the z-resolution should be dz. The user cannot have typed in 
non-integer values (for xcen,ycen,zcen)		
typical file line;
dz(microns) r(microns)  bright    
dr dz, in microns, gives displacement from the center of the light source. */
  if(iwh>0) {
	restartSectionCache(nsect);
	iz=0;
	talk("Start seeking center near ("+xcen+", "+ycen+", "+zcen+") where BrightSum="+
		getsum(xcen, ycen, zcen,beadSearchRad,beadSearchRad,width));
	while(iz < 8 && !centerIsCentered) {
		if((maxcol = (int)(.49 + maxrad/dxy + xcen)) >= width) maxcol = width-1;
		if((mincol = (int)(xcen - .49 - maxrad/dxy)) < 0) mincol = 0;
		if(mincol >= maxcol) mincol = maxcol-1;
		
		if((maxrow = (int)(.49 + maxrad/dxy + ycen)) >= height) maxrow = height-1;
		if((minrow = (int)(ycen - .49 - maxrad/dxy)) < 0) minrow = 0;
		if(minrow >= maxrow) minrow = maxrow-1;
		
		if((maxsect = (int)(.49 + maxdepth/dz + zcen)) >= nsect) maxsect = nsect-1;
		if((minsect = (int)(zcen - .49 - maxdepth/dz)) < 0) minsect = 0;
		if(minsect >= maxsect) minsect = maxsect-1;
		nradpts = (int)(2.49 + maxrad/dxy);
		xyzcen = findBeadCenter(beadSearchRad,beadSearchRad,xcen,ycen,zcen,
					minsect,maxsect,minrow,maxrow,mincol,maxcol,width,height,nsect);
		if((xcen == xyzcen[0]) && (ycen == xyzcen[1]) && (zcen == xyzcen[2]) )
			centerIsCentered = true;
		xcen = xyzcen[0];
		ycen = xyzcen[1];
		zcen = xyzcen[2];
		talk("Bead center location refined to ("+xcen+", "+ycen+", "+zcen+"). BrightSum="+xyzcen[3]);
		}
		
		lowSectNum = minsect;
		highSectNum = maxsect;
		double [] xyz = {xcen,ycen,zcen};
		moveActiveMarkerTo(xyz);
		// announce the new location of the center
		announceNewBeadCenter();

		if(iwh==1)  // we were just supposed to locate the center
			return;
			
		// compute the profiles
		numProfiles = maxsect-minsect+1;
		histoProfile = new int[numProfiles][nradpts];
		countsProfile = new int[numProfiles][nradpts];
		radProfile = new double[numProfiles][nradpts];
		oopsProfile  = new double[numProfiles][nradpts];
		
		totalLightInBead = 0;
		for(sect=minsect;sect <= maxsect; ++sect)  {
			ras = getsection(sect);
			for(row=minrow; row<=maxrow; ++row)
				for(col=mincol;col<=maxcol;col++) {
					delx = dxy*(col-xcen);  dely = dxy*(row-ycen); delz = dz*(sect-zcen);
					radsq = delx*delx + dely*dely;
					sphericalRadSq = radsq + delz*delz;
					if(radsq <= coneradsq) { // we're in the cone 5 by 5
						if((pix = ras[row*width + col]) < 0) pix += 256;
						irad = (int)(.49 + Math.sqrt(radsq)/dxy);
						if(irad>=nradpts) 
							talk("when row="+row+", col="+col+", irad = "+irad+" >= nradpts="+nradpts+
								", maxrad^2 = "+(maxrad*maxrad)+", coneradsq="+coneradsq);
						else {
							iz = sect-minsect;
							++countsProfile[iz][irad];
							histoProfile[iz][irad] += pix; 
							if(sphericalRadSq <= beadRadiusSq)
								totalLightInBead += pix;
							}
						}
					}
			}	
		
		// normalize and write the radial histograms.
		talk("totalLightInBead = "+totalLightInBead);
						
		for(sect=minsect;sect <= maxsect; ++sect)  {
			iz = sect-minsect;
			radProfile[iz] = extractSpreadSpot(histoProfile[iz],countsProfile[iz],nradpts);
			}
		profilesAreReady = true;
		writeButton.setText("write profiles to disk");
		}

		else if(iwh==0) {
		   double glow;
		   int numGlowPts=0;
		   int minsct = zcen,maxsct=zcen,iradmax=0;  

		
		for(sect=minsect;sect <= maxsect; ++sect)  {
			  iz = sect-minsect;
			  if(dz*Math.abs(sect-zcen) <= delzLim) { // record this profile
			  	if(sect<minsct) minsct=sect;
			  	if(sect>maxsct) maxsct=sect;
			  	for(irad=0;irad<nradpts;irad++)
					if(radProfile[iz][irad]>dimThresh) {
						++numGlowPts;
						if(irad>iradmax)
							iradmax=irad;
						}
					}
				}

			// write file text trailer in which no instances of 'iz=' can appear
			// because 'iz=' is the flag for a line with data.
			stg = "@Number of points in the bead's point spread function = "+numGlowPts;
			talk(stg);
			writer.writeAString("@filename= "+fileToUse.filename);
			writer.writeAString(stg);
			writer.writeAString("@x center of light source= "+xcen);
			writer.writeAString("@y center of light source= "+ycen);
			writer.writeAString("@z center section of light source= "+zcen);
			writer.writeAString("@bead search radius = "+beadSearchRad);
			writer.writeAString("@bead diameter (microns) = "+trunc(beadDiameter));
			writer.writeAString("@dimThreshold = "+trunc(dimThresh));
			writer.writeAString("@max cone radius surveyed from center (microns)= "+trunc(maxrad));
			writer.writeAString("@max cone z-depth surveyed from center (microns)= "+trunc(maxdepth));
			writer.writeAString("@z-depth cutoff chosen by user (microns)= "+trunc(delzLim));
			writer.writeAString("@lowest section number recorded="+minsct);
			writer.writeAString("@highest  section number recorded="+maxsct);
			writer.writeAString("@maximum number of radius cells recorded="+iradmax);			
			writer.writeAString("@pixel width (microns)= "+trunc(dxy));
			writer.writeAString("@section thickness (microns)= "+trunc(dz));
			writer.writeAString("@objective lens lens =  60X oil");
			writer.writeAString("@zoom factor =  4.0");
			writer.writeAString("@emission wavelength =  530nm");
			writer.writeAString("@excitation wavelength =  488nm");
			writer.writeAString("@rgb channel number = "+rgbchan);
			writer.writeAString("@EndOfHeader");	

		for(sect=minsect;sect <= maxsect; ++sect)  {
			  iz = sect-minsect;
			  if(dz*Math.abs(sect-zcen) <= delzLim) { // record this profile
			  	for(irad=0;irad<nradpts;irad++)
					if(radProfile[iz][irad]>dimThresh) {
						glow = radProfile[iz][irad]-dimThresh;
						stg = "iz="+(sect-minsct)+" delz="+trunc(dz*(sect-zcen))+" ir="+irad+" rad="+trunc(irad*dxy)+" glow="+
								trunc(glow);
						writer.writeAString(stg);
						}
					}
				}
			writer.writeAString("@EndOfFile");	
			}
		}

	private double [] extractSpreadSpot(int [] brightness, int [] counts, int npts) {
		double [] retn = new double[npts];
		int i,j,nlowpasses=2;
		
		for(i=0; i<npts; i++) {
			if(counts[i]>3) 
				retn[i] = (double )brightness[i]/(double )counts[i];
			else retn[i] = -77; // flags a value to ignore because of no statistical power
			}
		return retn;
		}

	private void makeProfileMonotone(double [] aray, int nb) {
		int i;
		for(i=nb-1; i>0; i--)
			if(aray[i-1] < aray[i])
				aray[i-1] = aray[i];
		}

	private void lowPassFilter(double [] aray, int nb) {
		double [] bfr = new double[nb+1];
		int i,nsmoothed=0;
		
		if(aray[0] >= 0. && aray[1] >=0.) {
			bfr[0] = (2.*aray[0] + aray[1])/3.;
			++nsmoothed;
			}
		else bfr[0] = aray[0];
			
		if(aray[nb-1] >= 0. && aray[nb-2] >=0.) {
			bfr[nb-1] = (2.*aray[nb-1] + aray[nb-2])/3.;
			++nsmoothed;
			}
		else bfr[nb-1] = aray[nb-1];
			
		for(i=1;i<nb-1;i++)
			if(aray[i-1] >= 0. && aray[i] >= 0. && aray[i+1] >= 0.) {
				bfr[i] = (aray[i-1]+2.*aray[i]+aray[i+1])/4.;
				++nsmoothed;
				}
			else bfr[i] = aray[i];
		for(i=0;i<nb;i++)
			aray[i] = bfr[i];
		// talk("lowPassFilter smoothed "+nsmoothed+" points out of "+nb);
		}

	private void blendAdjacentProfiles() {
		int i,k;
		double [] cc = blend(radProfile[0],.33333,radProfile[0],.33333,radProfile[1],.3333333,nradpts);
		double [] bb;
		
		for(i=1;i<numProfiles-1;i++) {
			bb=cc;
			cc=blend(radProfile[i-1],.25,radProfile[i],.5,radProfile[i+1],.25,nradpts);
			for(k=0;k<nradpts;k++)
				radProfile[i-1][k] = bb[k];
			}
		bb=cc;
		cc = blend(radProfile[numProfiles-1],.33333,radProfile[numProfiles-1],.33333,
			radProfile[numProfiles-2],.3333333,nradpts);
			
		for(k=0;k<nradpts;k++) {
			radProfile[numProfiles-2][k] = bb[k];
			radProfile[numProfiles-1][k] = cc[k];
			}		
		} 

	private double [] blend(double [] a1, double wt1, double [] a2, double wt2, double [] a3, double wt3, int nb) {
		double [] retn = new double[nb];
		int i;
		for(i=0;i<nb;i++) 
			if(a1[i]>=0. && a2[i]>=0. && a3[i]>=0.)
				retn[i] = wt1*a1[i] + wt2*a2[i] + wt3*a3[i]; 
			else retn[i]=a1[i];
		return retn;
		}
		
	public void changeJPanelSize(double ratio) {
		int pwidth = getSize().width;
		int pheight = getSize().height;
		pwidth = (int)(ratio*pwidth +.4999);
		pheight = (int)(ratio*pheight +.4999);
		setSize(pwidth,pheight);
		show();
		}

	static void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}
}

